/*****************************************************************************
**
**      Filename:   nivxi.h
**
**      Purpose:    Function prototypes for nivxint.c
**                  
**      Version 2.1                   20/04/2001            
**
**      Authors:    P.Bruckman,  J.Olszowska,  A.Spyrzewska   
**                        INP  Cracow 
**
*****************************************************************************/

#include        <basetsd.h>
#define         PAUSE_LENGTH    100  /* number of loops in the NI_pause function */

typedef    short   NIVXI_STATUS;    // try to mimick the NI ret type...


void* MapVXIAddress(     UINT32 accessparms,
                         UINT32 address,
                         INT32  timo,
                         UINT32 *window,
                         short  *ret);

int   UnMapVXIAddress(     UINT32 window );

int   MapVXIAddressSize(     UINT32 size );

int   GetWindowRange(      int     window,
					       UINT32 *wstart,
						   UINT32 *wend );

int   InitVXIlibrary( void );

int   CloseVXIlibrary( void );

NIVXI_STATUS VXIin   (   unsigned int accessparms,
                         UINT32 address,
                         unsigned int accwidth,
                         void   *value );

NIVXI_STATUS VXIout  (   unsigned int accessparms,
                         UINT32 address,
                         unsigned int accwidth,
                         UINT32 value );

void NI_pause();
