/* cloac_lib.h  UCL CLOAC module
   extracted from clkcntl.c GFM 981108
   GFM 990714 Add pulse input register */

/* Register offsets */
#define ENABLE    0x0
#define COMMAND   0x2
#define STRING    0x4
#define FREQUENCY 0x6
#define WINDOW    0x8
#define DELAY     0xA
#define STATE     0xC

/* Command strings loaded into "string" register */
#define TRIG      0x0003
#define SRST      0x0015
#define BCRST     0x0025
#define CAL1      0x1875
#define CAL2      0x00ff
#define PULSE     0x007f

/* Command register commands */
#define VSINGLETRIG   0x0001
#define VSRST         0x0002
#define VBCRST        0x0004
#define VCAL          0x0008
#define VSLOWCOM      0x0010
#define VOARST        0x0020
#define VBURST        0X0040
#define VBUSY         0x0080
#define LDTRIG        0x0100
#define LDSRST        0x0200
#define LDBCRST       0x0400
#define LDCAL1        0x0800
#define LDCAL2        0x1000
#define LDSLOWCOM     0x2000
#define RSTSLOWCOUNT  0x4000
#define LDVBURST      0X8000

/* Enable register bits */
#define ENINTCLK      0
#define ENINTRPTTRIG  1
#define ENRANDOMISER  2
#define ENINTSRST     3
#define ENINTBCRST    4
#define ENINTBUSY     5
#define ENEXTCLK      6
#define ENEXTTRIG     7
#define ENEXTSRST     8
#define ENEXTBCRST    9
#define ENEXTCAL     10
#define ENEXTBUSY1   11
#define ENEXTBUSY2   12
#define ENEXTBUSY3   13
#define ENEXTBUSY4   14
#define ENTRIGWIN    15

/* Function prototypes */
int cc_vmemap(unsigned long address);
void cc_sleep(int n);
int cc_load_enable(unsigned short value);
int cc_read_enable(unsigned short *value);
int cc_load_command(unsigned short value);
int cc_read_command(unsigned short *value);
int cc_load_string(unsigned short value);
int cc_load_frequency(unsigned short value);
int cc_read_frequency(unsigned short *value);
int cc_load_window(unsigned short value);
int cc_read_window(unsigned short *value);
int cc_load_delay(unsigned short value);
int cc_read_delay(unsigned short *value);
int cc_read_state(unsigned short *value);

