void ENCcompruns(Int_t run_a, Int_t firstscan_a, Int_t run_b, Int_t firstscan_b){
#define MAX_MODULES 18
#define MAX_CHTOT   12
#define MAX_LINKS    2
#define MAX_CHIPS    6

  Int_t nread=1,i=0,j,k,round,chipno,nmod,scans[3];
  //Int_t tsec=0,tfirst=0;
  Float_t gain[MAX_MODULES][MAX_LINKS][MAX_CHIPS],offset[MAX_MODULES][MAX_LINKS][MAX_CHIPS];
  Float_t noise[MAX_MODULES][MAX_LINKS][MAX_CHIPS],dif[MAX_CHTOT],chipid[MAX_CHTOT];
  Float_t nse1[MAX_MODULES][MAX_CHTOT], nse2[MAX_MODULES][MAX_CHTOT],data,maxy,miny;
  //char texta[1024],textb[1024],timestr[8], smon[32],sday[32],srun[5];
  char mname[MAX_MODULES][32],a[10],b[10],c[10],d[10];
  FILE* input;
  TDatime *dt = new TDatime;
  Int_t date = dt->GetDate();
  Float_t max_n=1800., min_n=1000.;
  Color_t col;
  Char_t line[1024],gtitle[64],h_title[64],f_name[128];
  Char_t texta[1024],textb[1024];
  Float_t charges[3] = {1.50,2.00,2.50};

  // load the 3pt-gain plot macro 
  gROOT->ProcessLine(".L systest/ScurveStabilityFit.cpp");

  for(j=0;j<3;j++)
    scans[j] = firstscan_a+j;

  for(j=0;j<MAX_CHTOT;j++)
    chipid[j] = (Float_t) j;

  sprintf(f_name,"D:\\sctvar\\data\\strun%d_%d.root",run_a,scans[0]);
  printf("opening file %s\n",f_name);
  TFile *strun = new TFile(f_name);
  nmod=0;
  for (i=0; i<MAX_MODULES; i++){
    if(i==0){
      TObjString* time  = (TObjString*)strun->Get("Time");
      TObjString* place = (TObjString*)strun->Get("Place");
    }
    sprintf(h_title,"ModuleName;%d",i+1);
    TObjString* name = (TObjString*)strun->Get(h_title);
    if(name){
      if(strcmp(name->GetName(),"missing")){
	sprintf(mname[nmod],"%s",name->GetName());
	nmod++;
      }
    }
  }
  strun->Close();
    
  // do the fitting
  ScurveStabilityFit(run_a,3,1,scans,charges,4,gain,offset,noise);
  for(i=0;i<nmod;i++){
    for(j=0;j<MAX_LINKS;j++){
      for(k=0;k<MAX_CHIPS;k++)
	nse1[i][k+6*j] = noise[i][j][k];
    }
  }

  // now the second run

  for(j=0;j<3;j++)
    scans[j] = firstscan_b+j;

  sprintf(f_name,"D:\\sctvar\\data\\strun%d_%d.root",run_b,scans[0]);
  printf("opening file %s\n",f_name);
  TFile *strun = new TFile(f_name);
  nmod=0;
  for (i=0; i<MAX_MODULES; i++){
    if(i==0){
      TObjString* time  = (TObjString*)strun->Get("Time");
      TObjString* place = (TObjString*)strun->Get("Place");
    }
    sprintf(h_title,"ModuleName;%d",i+1);
    TObjString* name = (TObjString*)strun->Get(h_title);
    if(name){
      if(strcmp(name->GetName(),"missing")){
	sprintf(mname[nmod],"%s",name->GetName());
	nmod++;
      }
    }
  }
  strun->Close();
    
  // do the fitting
  ScurveStabilityFit(run_b,3,1,scans,charges,4,gain,offset,noise);
  for(i=0;i<nmod;i++){
    for(j=0;j<MAX_LINKS;j++){
      for(k=0;k<MAX_CHIPS;k++)
	nse2[i][k+6*j] = noise[i][j][k];
    }
  }

  // open canvas
  TCanvas* c6= new TCanvas ("c6","ENC",1100,750);

  // write data to file and plot

  sprintf(f_name,"D:\\sctvar\\ps\\ENCcomp_%d.ps",date);
  ps = new TPostScript(f_name,112);

  sprintf(f_name,"D:\\sctvar\\results\\ENCcomp_%d.txt",date);
  FILE* output=fopen(f_name,"w");

  // WRITE ABSOLUTE NUMBERS

  fprintf(output,"absolute noise in ENC, run %d\n",run_a);
  fprintf(output,"chip\t");
  for(i=0;i<nmod;i++)
    fprintf(output,"%s\t",mname[i]);
  fprintf(output,"\n");

  for(chipno=0;chipno<MAX_CHTOT;chipno++){
    fprintf(output,"%d\t",chipno);
    for(i=0;i<nmod;i++)
      fprintf(output,"%.1f\t",nse1[i][chipno]);
    fprintf(output,"\n");
  }

  // WRITE ABSOLUTE NUMBERS

  fprintf(output,"absolute noise in ENC, run %d\n",run_b);
  fprintf(output,"chip\t");
  for(i=0;i<nmod;i++)
    fprintf(output,"%s\t",mname[i]);
  fprintf(output,"\n");

  for(chipno=0;chipno<MAX_CHTOT;chipno++){
    fprintf(output,"%d\t",chipno);
    for(i=0;i<nmod;i++)
      fprintf(output,"%.1f\t",nse2[i][chipno]);
    fprintf(output,"\n");
  }

  // plot

  ps->NewPage();
  c6->cd();
  c6->Clear();
  pad_text   = new TPad("pad_text", "Text",        0.00,0.90,1.00,1.00);
  pad_plot   = new TPad("pad_plot", "Plots",       0.00,0.00,1.00,0.90);
  pad_text->Draw();
  pad_plot->Draw();
  c6->Update();

  pad_text->cd();
  TPaveText *t1 = new TPaveText(0.0,0.0,1.0,1.0);
  t1->SetFillColor(10);
  t1->SetTextAlign(13);
  t1->SetTextSize(0.3);
  t1->SetTextColor(4);
  sprintf(line,"ATLAS SCT: ENC from 3pt gain");
  if(time)  sprintf(line,"%s  -  %s",line,time->GetName());
  if(place) sprintf(line,"%s  -  %s",line,place->GetName());
  t1->AddText(line);
  sprintf(line,"Runb %d   Scansb %d-%d  -  Runa %d   Scansa %d-%d", run_b,firstscan_b,firstscan_b+2, run_a,firstscan_a,firstscan_a+2);
  t1->AddText(line);
  sprintf(line,"Input-noise from 3point gain scans - Comparison b-a",1.0);
  t1->AddText(line);
  t1->Draw();
  c6->Update();

  pad_plot->cd();
  maxy=3000.;
  miny=-500.;
  leg = new TLegend(.9,.4,.98,.95);
  leg->SetTextSize(0.03);
  for(i=0;i<nmod;i++){
    for(j=0;j<MAX_CHTOT;j++)
      dif[j] = nse2[i][j]-nse1[i][j];
    gr = new TGraph(MAX_CHTOT,chipid,dif);
    sprintf(gtitle,"Difference in noise");
    gr->SetTitle(gtitle);
    if(i<8){
      col = (Color_t) i+1;
      gr->SetMarkerStyle(20);
    }
    else{
      gr->SetMarkerStyle(21);
      col = (Color_t) i-7;
    }
    gr->SetMarkerSize(1);
    gr->SetMarkerColor(col);
    gr->SetLineColor(col);
    gr->SetMaximum((Double_t)maxy);
    gr->SetMinimum((Double_t)miny);
    // legend
    leg->AddEntry(gr,mname[i],"p");
    // draw graphs
    if(i==0) {
      gr->Draw("APL");
      gr->GetXaxis()->SetTitle("Chip");
      gr->GetYaxis()->SetTitle("Difference in input-noise (ENC)");
      gr->Draw("APL");
    }
    else
      gr->Draw("PL");
  }
  leg->Draw();
  c6->Update();

  fprintf(output,"noise-difference in ENC\n");
  fprintf(output,"chip\t");
  for(i=0;i<nmod;i++)
    fprintf(output,"%s\t",mname[i]);
  fprintf(output,"\n");

  for(j=0;j<MAX_CHTOT;j++){
    fprintf(output,"%d\t",j);
    for(i=0;i<nmod;i++)
      fprintf(output,"%.1f\t",nse2[i][j]-nse1[i][j]);
    fprintf(output,"\n");
  }


  ps->Close();
  fclose(output);

  return;
}
