#include <parameters.h>
#include "Evtree.h"

void FixTree(Int_t run, Int_t scan){

  Int_t moi,i,j,nevbins,nmods, events, offset;
  Char_t mname[MAX_MODULES][32], hname[32], htitle[64],line[128], fname[128],info[256];
  TH2F* hit_evt0[MAX_MODULES];
  TH2F* hit_evt1[MAX_MODULES];
  Evtree* m[MAX_MODULES];
  TTree* tcopya[MAX_MODULES],tcopyb[MAX_MODULES];

  sprintf(fname,"%sstrun%d_%d.root",DATA_DIRECTORY,run,scan);
  TFile *f=new TFile(fname);
  
  // fill histos
  nmods = 0;
  for(moi=0;moi<MAX_MODULES;moi++){

    sprintf(mname[moi],"ModuleName;%d",moi+1);
    TObjString* name  = (TObjString*) f->Get(mname[moi]);
    if(name){
      sprintf(mname[moi],"%s",name->GetName());
      if(strcmp(mname[moi],"missing")){
	nmods++;
	printf("processing module %d %s...  \n",moi,mname[moi]);
      }
      else
	break;
    }
    else
      break;

    sprintf(htitle,"EvTree_m%d",moi);
    //sprintf(htitle,"EvTree;%d",moi+1);
    //f->Cd();
    TTree* tree = (TTree*)gDirectory->Get(htitle);
    tree->Print();
    events = tree->GetEntries();
    //g->Cd();
    tcopya[moi] = tree->CopyTree("","",events/2,0);
    tcopyb[moi] = tree->CopyTree("","",events/2,events/2);
  }

  printf("Found %d modules\n",nmods);

  sprintf(fname,"%sstrun%d_%da.root",DATA_DIRECTORY,run,scan);
  TFile *g=new TFile(fname,"RECREATE");
  for(moi=0;moi<nmods;moi++){
    sprintf(htitle,"EvTree_m%d",moi);
    tcopya[moi]->Write(htitle);
    TObjString * mns = new TObjString(mname[moi]);
    mns->Write("ModuleName");
    delete mns;
  }
  g->Close();
  sprintf(fname,"%sstrun%d_%db.root",DATA_DIRECTORY,run,scan);
  TFile *g=new TFile(fname,"RECREATE");
  for(moi=0;moi<nmods;moi++){
    sprintf(htitle,"EvTree_m%d",moi);
    tcopyb[moi]->Write(htitle);
    TObjString * mns = new TObjString(mname[moi]);
    mns->Write("ModuleName");
    delete mns;
  }
  g->Close();

  f->Close();

  return;
}
