#include <parameters.h>
#define MAXNDAT 20

void InjectionSurf(Int_t *run, Int_t *scans, Char_t *exttit=0){

  Int_t i,j,k,chip,goodchip, nread=1, nmod, refer=-1, chan,link;
  Float_t refns[MAX_MODULES][MAX_LINKS][MAX_CHIPS*128];
  Float_t injns[MAX_MODULES][MAX_LINKS][MAX_CHIPS*128];
  Float_t diff[144],maxnse=0.,tmp;
  Char_t fname[128],mname[30][MAX_MODULES],text[128],line[1024];

  TGraph *grm;
  TPostScript *ps;

  FILE *output;
  TFile *strun;
  TH1F* h_sigma;

  refer = 0;
  
  // read from data files
  for(i=0;i<2;i++){
    sprintf(fname,"%sstrun%d_%d.root",DATA_DIRECTORY,run[i],scans[i]);
    strun = new TFile(fname);
    TObjString* time  = (TObjString*)strun->Get("Time");
    TObjString* place = (TObjString*)strun->Get("Place");
    for(j=0;j<MAX_MODULES;j++){
      sprintf(text,"ModuleName;%d",j+1);
      TObjString* name = (TObjString*)strun->Get(text);
      if(name){
	if(strcmp(name->GetName(),"missing")){
	  sprintf(mname[j],"%s",name->GetName());
	}
	else
	  break;
      }
      else
	break;
      for(link=0;link<MAX_LINKS;link++){
	sprintf(text,"h_sigma%d;%d",link,j+1);
	h_sigma= (TH1F*)strun->Get(text);
	for(chan=0;chan<(MAX_CHIPS*128);chan++){
	  if(i)
	    injns[j][link][chan] = 6240/55.*h_sigma->GetBinContent(chan);
	  else
	    refns[j][link][chan] = 6240/55.*h_sigma->GetBinContent(chan);
	}
      }
    }
    strun->Close();
    if(i==0){
      nmod = j;
      printf("found %d modules\n",nmod);
    }
  }
  
  TH2F* pickup[2];
  pickup[0] = new TH2F("put","Top sides",nmod,0,(Float_t) nmod,MAX_CHIPS*32,
		       0.,6);
  pickup[1] = new TH2F("pub","Bottom sides",nmod,0,(Float_t) nmod,MAX_CHIPS*32,
		       0.,6);

  for(link=0;link<MAX_LINKS;link++){
    for(i=0;i<nmod;i++){
      for(chan=0;chan<MAX_CHIPS*128;chan++){
	if(link) 
	  tmp=(Float_t)chan/128.;
	else
	  tmp = (Float_t)(MAX_CHIPS*128-chan)/128.;
	pickup[link]->Fill((Float_t) i,tmp,
			   (injns[i][link][chan]-refns[i][link][chan])/4.);
      }
    }
  }

  // get time/place info
  
  sprintf(fname,"%sstrun%d_%d.root",DATA_DIRECTORY,run[refer],scans[refer]);

  // plot
  
  // open canvas
  TCanvas* cinj= new TCanvas ("cinj","Noise Injection",1100,750);
  gStyle->SetOptStat(0);
  
  /*
  // define colour palette
  const Int_t colNum=50;
  Int_t palette[colNum];

  for(Int_t i=0;i<colNum;i++){
    if(! gROOT->GetColor(100+i+colNum)){
      TColor *color = new TColor (100+i+colNum,1-(i/(Float_t) colNum),1-(i/(Float_t) colNum),1,"");
    }else{
      TColor *color = gROOT->GetColor(100+i);
      color->SetRGB(1-(i/(Float_t) colNum),1-(i/(Float_t) colNum),1);
    }
    palette[i]=100+i;
  }
  gStyle->SetPalette(colNum,palette);


  palette[0]=0;
  palette[1]=2;
  palette[2]=3;
  palette[3]=4;
  palette[4]=5;
  palette[5]=6;
  palette[6]=7;
  palette[7]=1;
  gStyle->SetPalette(8,palette);
  */

  gStyle->SetPalette(1);

  // open ps file
  sprintf(fname,"%sNinjSurf_%d_%d.ps",PS_DIRECTORY,run[refer],scans[refer]);
  ps = new TPostScript(fname,112); 

  /*
  ps->NewPage();

  cinj->cd();
  cinj->Clear();
  pad_text   = new TPad("pad_text", "Text",        0.00,0.90,1.00,1.00,0);
  pad_plot   = new TPad("pad_plot", "Plots",       0.00,0.00,1.00,0.90,0);
  pad_text->Draw();
  pad_plot->Draw();
  pad_plot->Divide(2,1,0,0);
  cinj->Update();

  pad_text->cd();
  TPaveText *t1 = new TPaveText(0.0,0.0,1.0,1.0);
  t1->SetFillColor(10);
  t1->SetTextAlign(13);
  t1->SetTextSize(0.3);
  t1->SetTextColor(4);
  sprintf(line,"ATLAS SCT: pick-up with noise injection");
  if(time)  sprintf(line,"%s  -  %s",line,time->GetName());
  if(place) sprintf(line,"%s  -  %s",line,place->GetName());
  t1->AddText(line);
  sprintf(line,"Threshold scans -> noise-difference injection (run %d, scan %d) - zero-injection (run %d, scan %d)",
	  run[1],scans[1],run[0],scans[0]);
  t1->AddText(line);
  if(exttit) t1->AddText(exttit);
  t1->Draw();
  cinj->Update();
  
  for(link=0;link<2;link++){
    pad_plot->cd(link+1);
    gPad->SetRightMargin(0.2);
    gPad->SetBottomMargin(0.2);
    pickup[link]->SetXTitle("Module");
    pickup[link]->SetZTitle("Excess noise (ENC)");
    pickup[link]->SetTitleOffset(1.6,"X");
    pickup[link]->SetTitleOffset(1.8,"Z");
    pickup[link]->SetNdivisions(nmod,"X");
    pickup[link]->SetNdivisions(0,"Y");
    pickup[link]->Draw("COLZ");
    if(link){
      TGaxis *yax = new TGaxis(0,0,0,6,6,12,606,"MIW");
    } else{
      TF1 *f1=new TF1("f1","-x",-1,5);
      TGaxis *yax = new TGaxis(0,0,0,6,"f1",606,"MIW");
    }
    yax->SetTitle("Chip");
    yax->Draw();
  }

  cinj->Update();

  printf("type anything to continue:  ");
  scanf("%s",text);
  */

  ps->NewPage();

  cinj->cd();
  cinj->Clear();
  pad_text   = new TPad("pad_text", "Text",        0.00,0.90,1.00,1.00,0);
  pad_plot   = new TPad("pad_plot", "Plots",       0.00,0.00,1.00,0.90,0);
  pad_text->Draw();
  pad_plot->Draw();
  pad_plot->Divide(2,1,0,0);
  cinj->Update();

  pad_text->cd();
  TPaveText *t1 = new TPaveText(0.0,0.0,1.0,1.0);
  t1->SetFillColor(10);
  t1->SetTextAlign(13);
  t1->SetTextSize(0.3);
  t1->SetTextColor(4);
  sprintf(line,"ATLAS SCT: pick-up with noise injection");
  if(time)  sprintf(line,"%s  -  %s",line,time->GetName());
  if(place) sprintf(line,"%s  -  %s",line,place->GetName());
  t1->AddText(line);
  sprintf(line,"Threshold scans -> noise-difference injection (run %d, scan %d) - zero-injection (run %d, scan %d)",
	  run[1],scans[1],run[0],scans[0]);
  t1->AddText(line);
  if(exttit) t1->AddText(exttit);
  t1->Draw();
  cinj->Update();
  
  for(link=0;link<2;link++){
    pad_plot->cd(link+1);
    gPad->SetRightMargin(0.05);
    gPad->SetLeftMargin(0.15);
    gPad->SetBottomMargin(0.15);
    gPad->SetTheta(50.);
    gPad->SetPhi(310.);
    pickup[link]->SetXTitle("Module");
    pickup[link]->SetYTitle("Chip");
    pickup[link]->SetZTitle("Excess noise (ENC)");
    pickup[link]->SetTitleOffset(2.,"X");
    pickup[link]->SetTitleOffset(1.7,"Y");
    pickup[link]->SetTitleOffset(1.8,"Z");
    //pickup[link]->GetYaxis()->SetLabelColor(0);
    pickup[link]->SetNdivisions(12,"X");
    pickup[link]->SetNdivisions(0,"Y");
    pickup[link]->Draw("LEGO2");
    for(i=0;i<nmod;i++){
      pickup[link]->GetXaxis()->SetBinLabel(i+1,mname[i]);
    }    
    pickup[link]->GetXaxis()->SetLabelSize(0.045);
    for(i=0;i<MAX_CHIPS;i++){
      TText s;
      s.SetTextSize(0.035);
      s.SetTextAngle(-57);
      if(link)
	sprintf(text,"%d",MAX_CHIPS+i);
      else
	sprintf(text,"%d",MAX_CHIPS-1-i);
      //s.DrawText(0.+.15*(Double_t)i,-1+.095*(Double_t)i,text);
      pickup[link]->GetYaxis()->SetBinLabel(5+i*10,text);
      pickup[link]->GetYaxis()->SetBinLabel(1+i*10,"|");
    }    
    pickup[link]->GetYaxis()->SetBinLabel(MAX_CHIPS*10,"|");
    pickup[link]->GetYaxis()->SetTickLength(0.);
    pickup[link]->GetYaxis()->SetLabelOffset(0.03);
    pickup[link]->GetYaxis()->SetLabelSize(0.045);
  }

  cinj->Update();

  ps->Close();

  return;
}

void InjectionSurf(Int_t run, Int_t scan, Char_t *exttit=0){

  Int_t runs[2], scans[2];

  runs[0] = run;
  runs[1] = run;

  scans[0] = scan-1;
  scans[1] = scan;

  InjectionSurf(runs,scans,exttit);

}
