void NOvsTemp(){
  #define MAX_SCANS   200
  #define MAX_MODULES 18
  #define N_TEMPS     3

  //declarations
    
  Int_t n;
  Color_t col;

  Char_t filename[40],module[20],gtitle[60],histogram[20],histogram2[20],modname[20];
  Char_t fname[40],line[1024];
  Char_t directory[40] = "D:\\sctvar\\ps\\";

  Int_t first,last ,tpoint,alltrg;
  Int_t Nevt,i,j,t,s,link,chip,firstchan,lastchan,h,run,firstscan,lastscan;
  //Int_t pass[MAX_SCANS][12],sumpass[12];
  Int_t runs[3]={641,642,642},fscs[3]={140,1,11},lscs[3]={150,10,20};

  Float_t temps[3]={5.0,10.0,15.0},mnocc[3][MAX_MODULES][12];
  Float_t ntrigs,pass[12];
  Float_t x,occ,sum[MAX_SCANS][12];
  Float_t truehours[MAX_SCANS];
  Float_t mean[12],mean1d[3],miny,maxy,occcut=1.e-3;

  Double_t hours;

  TDatime *dt = new TDatime;
  Int_t date = dt->GetDate();

  // arrays with binomial upper and lower errors

  // to make arrays easier to follow set first scan = 0 and last scan = last - first
  first=0;
  last=lastscan-firstscan;
 
  // open new canvas
  TCanvas* can;
  can = new TCanvas("novstem","novstem",1100,750);
  gStyle->SetOptStat(0);
  gStyle->SetOptFit(0);      

  // open PS output file
  sprintf(fname,"%sNOvsTemp_%d.ps",directory,date);
  ps = new TPostScript(fname,112);

  // loop over all modules

  for(h=0;h<MAX_MODULES;h++){
    
    maxy = 0.;
    miny = 1000.;

    // loop ovet T-points
    for(tpoint=0;tpoint<3;tpoint++){

      run       = runs[tpoint];
      firstscan = fscs[tpoint];
      lastscan  = lscs[tpoint];

      first=0;
      last=lastscan-firstscan;
      for(i=0;i<12;i++)
	mnocc[tpoint][h][i] = 0.;
      alltrg = 0;

      //loop over all scans (time)
      
      for (i=first;i<=last;i++){
	
	//write the file to open to char string and open the file
	
	j=firstscan+i;
	
	sprintf(filename,"\\\\Pcephl01\\sctvar\\data\\strun%d_%d.root",run,j);
	TFile *f=new TFile(filename);
	
	sprintf(histogram,"h_accbst0_%d;1",h);
	sprintf(histogram2,"h_accbst1_%d;1",h);
	
	TH1F *histo = (TH1F*) f->Get(histogram);
	TH1F *histo2 = (TH1F*) f->Get(histogram2);
	
	//get the time stamp and name

	sprintf(modname,"ModuleName;%d",h+1);
	//      printf("%s",modname);
	TObjString* time  = (TObjString*) f->Get("Time");
	TObjString* place = (TObjString*) f->Get("Place");
	TObjString* clock = (TObjString*) f->Get("Clock");     
	TObjString* name  = (TObjString*) f->Get(modname);
	if(name){
	}
	else{
	  goto nomod;
	}
	
	TObjString *notrig  = (TObjString*) f->Get("Ntrig");
	
	//write the time stamp to variable hours and no. trigs to ntrigs
	
	sscanf(clock->GetName(),"%lf", &hours);
	sscanf(name->GetName(),"%s", module);
	sscanf(notrig->GetName(),"%f", &ntrigs);
	
	//find the mean number of hits over each chip
	
	for (chip=0;chip<12;chip++){
	  mean[chip]=0.;
	  pass[chip]=0;
	  if(chip<6){
	    firstchan=(chip*128)+1;
	    lastchan=(chip*128)+128;
	    for (t=firstchan;t<=lastchan;t++) {
	      x = histo->GetBinContent(t);
	      if(x<(ntrigs*occcut)){
		mean[chip] += x;
		pass[chip]++;
	      }
	    }
	  }
	  else{
	    firstchan=((chip-6)*128)+1;
	    lastchan=((chip-6)*128)+128;
	    for (t=firstchan;t<=lastchan;t++) {
	      x = histo2->GetBinContent(t);
	      if(x<(ntrigs*occcut)){
		mean[chip] += x;
		pass[chip]++;
	      }
	    }
	  }
	  mean[chip]=mean[chip]/(Float_t)(ntrigs*(pass[chip]));
	  mnocc[tpoint][h][chip]+=mean[chip];
	}
	f->Close();
      }
      for(i=0;i<12;i++){
	mnocc[tpoint][h][i]/=(Float_t)last;
	//printf("%e\t",mnocc[tpoint][h][i]);
	if(mnocc[tpoint][h][i]>maxy) maxy = mnocc[tpoint][h][i];
	if(mnocc[tpoint][h][i]<miny) miny = mnocc[tpoint][h][i];
      }
    }
    // plot the result
    ps->NewPage();
    can->cd();
    can->Clear();
    pad_text   = new TPad("pad_text", "Text",        0.00,0.90,1.00,1.00,33);
    pad_plot   = new TPad("pad_plot", "Plots",       0.00,0.00,1.00,0.90,33);
    pad_text->Draw();
    pad_plot->Draw();
    pad_plot->Divide(1,2,0,0);

    pad_text->cd();
    TPaveText *t1 = new TPaveText(0.0,0.0,1.0,1.0);
    t1->SetFillColor(10);
    t1->SetTextAlign(13);
    t1->SetTextSize(0.3);
    t1->SetTextColor(4);
    sprintf(line,"ATLAS SCT: Noise Occ. vs Temp.");
    if(time)  sprintf(line,"%s  -  %s",line,time->GetName());
    if(place) sprintf(line,"%s  -  %s",line,place->GetName());
    sprintf(line,"%s  -  Module %s",line,module);
    t1->AddText(line);
    sprintf(line,"Run %d   Start Scan %d   Module %d", run,firstscan,h);
    t1->AddText(line);
    sprintf(line,"Noise Occupancy at Qthr=%.1ffC vs Temperature - Projection per Chip,",1.0);
    t1->AddText(line);
    t1->Draw();
    can->Update();

    maxy*=1.1;
    miny*=0.9;
    for(j=0;j<12;j++){
      for(i=0;i<3;i++)
	mean1d[i]=mnocc[i][h][j];
      gr = new TGraph(3,temps,mean1d);
      if(j==0){
	sprintf(gtitle,"Stream 0");
	pad_plot->cd(1);
	gr->SetTitle(gtitle);
      }
      if(j==6){
	sprintf(gtitle,"Stream 1");
	pad_plot->cd(2);
	gr->SetTitle(gtitle);
      }
      gr->SetMarkerStyle(20);
      gr->SetMarkerSize(1);
      if(j<6)
	col = (Color_t) j+1;
      else
	col = (Color_t) j-5;
      gr->SetMarkerColor(col);
      gr->SetLineColor(col);
      gr->SetMaximum((Double_t)maxy);
      gr->SetMinimum((Double_t)miny);
      // write legend
      if(j==0) {
	leg = new TLegend(.85,.7,.98,.95);
	leg->SetTextSize(0.05);
      }
      if(j==6){
	leg = new TLegend(.85,.7,.98,.95);
	leg->SetTextSize(0.05);
      }
      sprintf(gtitle,"Chip %d",j);
      leg->AddEntry(gr,gtitle,"p");
      if(j==5 || j==11) leg->Draw();
      // draw graphs
      if(j==0 || j==6) 
	gr->Draw("APL");
      else
	gr->Draw("PL");
      if(j==0 || j==6) {
	gr->GetXaxis()->SetTitle("Chiller Temperature (C)");
	gr->GetYaxis()->SetTitle("Occupancy");
	gr->Draw("APL");
      }
    }
    can->Update();
  }
 nomod:

  ps->Close();
}
