void cmn_chmx3(Int_t runno, Int_t scanno) {

  gROOT->Reset();
  
#include "../macros/systest/Evtree.h"
#include "../macros/parameters.h"

#define MAX_MOD 12

  Int_t MAX_CHIPS = MAX_MOD*12, nevt;
 

  Char_t filename[70],module0[30],module1[30], filestore[50],mod_name[50],mname[12][50];

  TDatime *dt = new TDatime;
  printf("starting program at %d\n",dt->GetTime());

  // define histogram

  TH2F *histo = new TH2F("histo","correlated noise chip by chip",MAX_CHIPS,-0.5,MAX_CHIPS-0.5,MAX_CHIPS,-0.5,MAX_CHIPS-0.5);
  histo->SetStats(kFALSE);

  //open the file

  TFile* f;
  sprintf(filename,"d://sctvar//data//strun%d_%d.root",runno,scanno);
  f = new TFile(filename);
  
  //loop over modules (over the trees) and open everything

  Float_t cont, meansqs[144], hpe[144] ,hpe2[144];
 
  Float_t mean[144],sd[144], meansqd[144], meanprod[144][144], correl[144][144]; 

  Double_t sumsqd[144],sum[144], prod[144][144];
 
  Evtree* m[MAX_MOD];
  TTree* tree[MAX_MOD];

  for(Int_t mod=0;mod<MAX_MOD;mod++){
 
    sprintf(mod_name,"ModuleName;%d",mod+1);
    TObjString* name = (TObjString*)f->Get(mod_name);    
    sprintf(mname[mod],"%s",name->GetName());
    printf("%s\n",mname[mod]);

    sprintf(module0,"EvTree_m%d",mod);
    tree[mod] = (TTree*)gDirectory->Get(module0);
    m[mod] = new Evtree(tree[mod]);
   
    nevt = tree[mod]->GetEntries();
    printf("Tree for module %s has %d entries\n",mname[mod],nevt); 
    //printf("%d\n",m[mod]);
    //m[0]->GetEntry(0);

    printf("%s\n",".");
    printf("%s\n","..");
 
  }
  //nevt=10;

  //now loop over the events and the chips

  for(Int_t chip=0;chip<MAX_CHIPS;chip++){
    sum[chip]=0.0;
    sumsqd[chip]=0.0;
    for(Int_t chip2=0;chip2<MAX_CHIPS;chip2++){
      prod[chip][chip2]=0.0;
    }
  }

  //start the event looop

  for(Int_t ev=0;ev<nevt;ev++){
    
    //laod arrays
    
    for(mod=0;mod<MAX_MOD;mod++){
      m[mod]->GetEntry(ev);
    }
 
    //get number of hits per chip in this event, hpe[chip]
  
    Int_t mod=0;
    for(Int_t chip=0;chip<(MAX_CHIPS);chip++){
  
      if(chip%12==0){
	mod=mod+1;
      }
     
      hpe[chip]=0.0;
      for(Int_t strip=0;strip<128;strip++){
	if((chip-((mod-1)*12))<6){
	    cont = m[mod-1]->strm0[strip+((chip-((mod-1)*12))*128)];
	    hpe[chip]=hpe[chip]+cont;
	}else{
	  cont = m[mod-1]->strm1[strip+(((chip-((mod-1)*12))-6)*128)];
	  hpe[chip]=hpe[chip]+cont;
	}
      }	
    }
    
  
    for(Int_t chip=0;chip<(MAX_CHIPS);chip++){
    
      sum[chip]=sum[chip]+(Double_t)hpe[chip];
      sumsqd[chip]=sumsqd[chip]+(Double_t)(hpe[chip])**2.0;
      
      for(Int_t chip2=chip+1;chip2<(MAX_MOD*12);chip2++){
	
	prod[chip][chip2]=prod[chip][chip2]+((Double_t)hpe[chip]*(Double_t)hpe[chip2]);

      }
    }
    if(ev%1000==0) printf("%d \n",ev);  
    
  }

  /*
    
    Int_t mod=0;
    for(Int_t chip=0;chip<(MAX_CHIPS);chip++){
    
    if(chip%12==0){
    mod=mod+1;
    }
    //printf("%s %d\n","module",mod);
    hpe[chip]=0.0;   
    //sum[chip]=0.0; 
    //sumsqd[chip]=0.0;
    
    //printf("%s\n","here");
    //printf("%d %d\n",m[mod-1], ev);
    
    // m[mod-1]->GetEntry(ev);
    
    //printf("%s\n","there");
    
    for(Int_t strip=0;strip<128;strip++){
    if((chip-((mod-1)*12))<6){
    cont = m[mod-1]->strm0[strip+((chip-((mod-1)*12))*128)];
    hpe[chip]=hpe[chip]+cont;
    }else{
    cont = m[mod-1]->strm1[strip+(((chip-((mod-1)*12))-6)*128)];
    hpe[chip]=hpe[chip]+cont;
    }
    }	
    
    sum[chip]=sum[chip]+(Double_t)hpe[chip];
    //printf("%d %f %f \n",mod,hpe[chip],sum[chip]);
    sumsqd[chip]=sumsqd[chip]+(Double_t)(hpe[chip])**2.0;
    
    Int_t mod2=0;
    for(Int_t chip2=0;chip2<(MAX_MOD*12);chip2++){
    
    if(chip2%12==0){
    mod2=mod2+1;
    }
    
    hpe2[chip2]=0.0;
    //prod[chip][chip2]=0.0;
    
    //m[mod2-1]->GetEntry(ev);
    
    for(Int_t strip=0;strip<128;strip++){
    if((chip2-((mod2-1)*12))<6){
    cont = m[mod2-1]->strm0[strip+((chip2-((mod2-1)*12))*128)];
    hpe2[chip2]=hpe2[chip2]+cont;
    //printf("%f \n",cont);
    }else{
    cont = m[mod2-1]->strm1[strip+(((chip2-((mod2-1)*12))-6)*128)];
    hpe2[chip2]=hpe2[chip2]+cont; 
    //printf("%f \n",cont);
    }
    }	
    
    prod[chip][chip2]=prod[chip][chip2]+((Double_t)hpe[chip]*(Double_t)hpe2[chip2]);
    //printf("%f \n",prod[chip][chip2]);
    }
    }
    
    
    
    printf("%d \n",ev);
    
    }
    
  */

  
  //now have arrays sum, sumsqd and prod

  //do the maths on the arrays
  
  for(chip=0;chip<MAX_CHIPS;chip++){
  
    //find mean for chips
    
    mean[chip]=(Float_t)sum[chip]/(Float_t)nevt;
  
    //find mean of squares for chip

    meansqs[chip]=(Float_t)sumsqd[chip]/(Float_t)nevt;

    //find mean sqd

    meansqd[chip]=(mean[chip])**2;

    for(chip2=0;chip2<MAX_CHIPS;chip2++){

      //find mean of products

      meanprod[chip][chip2]=prod[chip][chip2]/(Float_t)nevt;
    }
  }
  
  for(chip=0;chip<MAX_CHIPS;chip++){
    histo->Fill(chip,chip,1.);  
    for(chip2=chip+1;chip2<MAX_CHIPS;chip2++){
     
      if((((meansqs[chip]-meansqd[chip])**0.5)*((meansqs[chip2]-meansqd[chip2])**0.5))==0){
	correl[chip][chip2]=0.0;
      }else{      
	correl[chip][chip2] = (meanprod[chip][chip2]-(mean[chip]*mean[chip2]))/(((meansqs[chip]-meansqd[chip])**0.5)*((meansqs[chip2]-meansqd[chip2])**0.5));
      }

      //printf("%f %f %f %f %f %f %f %f\n", mean[chip], meansqd[chip], meansqs[chip], mean[chip2], meansqd[chip2], meansqs[chip2], meanprod[chip][chip2], correl[chip][chip2]);
      
      //printf("%s %d %d %s %f\n","correlation between chips ",chip, chip2, "is ", correl[chip][chip2]);
      histo->Fill(chip,chip2,correl[chip][chip2]);  
      histo->Fill(chip2,chip,correl[chip][chip2]);  
    }
  }
  sprintf(filestore,"d:\\sctvar\\data\\cmn_%d_%d.root",runno,scanno);
  TFile store(filestore,"recreate");
  histo->Write();
  store->Close();
  
  TDatime *dt2 = new TDatime;
  printf("finished program at %d\n",dt2->GetTime());

  return;
}
