#include <parameters.h>

void fitl1a(){

  Int_t i,j;
  TFile *strun;
  Char_t fname[128];
  Double_t pars[3],id[12],mean[12],sig[12];

  TCanvas *can = new TCanvas("test","fits",1100,750);

  TF1 *f1 = new TF1("f1","gaus",1,3);

  sprintf(fname,"%sstrun914_17.root",DATA_DIRECTORY);
  strun = new TFile(fname,"R");

  if(!strun) return;

  for(i=0;i<12;i++){
    
    can->cd();
    sprintf(fname,"h_accbst1_%d",i);
    TH1F *hi = (TH1F*) strun->Get(fname);
    hi->Draw();
    hi->Fit("f1");
    f1->GetParameters(pars);
    mean[i] = pars[1];
    sig[i] = pars[2];
    id[i] = (Double_t) i;
    can->Update();
  }

  TGraph *grm = new TGraph(12,id,mean);
  TGraph *grs = new TGraph(12,id,sig);

  can->Divide(2,1,0,0);
  can->cd(1);
  grm->SetMarkerStyle(20);
  grm->SetMaximum(200);
  grm->Draw("AP");
  can->cd(2);
  grs->SetMaximum(80);
  grs->SetMarkerStyle(20);
  grs->Draw("AP");

  return;
}
