#define MAXIT 50

void idetlog(Int_t index){

  Char_t h_title[128];
  Double_t idet[MAXIT],time[MAXIT],et1,et2,et[MAXIT],vdet[MAXIT],t[MAXIT],t1,t2;
  Int_t i;
  TObjString* dcsobj;

  // open canvas
  TCanvas* c6= new TCanvas ("c6","DCS2",700,850);

  sprintf(h_title,"J:\\barrelsct\\irrad_test\\dcslog_%d.root",index);
  TFile strun(h_title);

  for(i=0;i<MAXIT;i++){
    sprintf(h_title,"clk;%d",i+1);
    dcsobj = (TObjString*)strun->Get(h_title);
    if(dcsobj==0) break;
    sscanf(dcsobj->GetName(),"%lf",&time[i]);

    sprintf(h_title,"Idet;%d",i+1);
    dcsobj = (TObjString*)strun->Get(h_title);
    sscanf(dcsobj->GetName(),"%lf",&idet[i]);

    sprintf(h_title,"Vdet;%d",i+1);
    dcsobj = (TObjString*)strun->Get(h_title);
    sscanf(dcsobj->GetName(),"%lf",&vdet[i]);

    sprintf(h_title,"ET1;%d",i+1);
    dcsobj = (TObjString*)strun->Get(h_title);
    sscanf(dcsobj->GetName(),"%lf",&et1);
    sprintf(h_title,"ET2;%d",i+1);
    dcsobj = (TObjString*)strun->Get(h_title);
    sscanf(dcsobj->GetName(),"%lf",&et2);
    et[i] = (et1+et2)/2.;

    sprintf(h_title,"T1;%d",i+1);
    dcsobj = (TObjString*)strun->Get(h_title);
    sscanf(dcsobj->GetName(),"%lf",&t1);
    sprintf(h_title,"T2;%d",i+1);
    dcsobj = (TObjString*)strun->Get(h_title);
    sscanf(dcsobj->GetName(),"%lf",&t2);
    t[i] = (t1+t2)/2.;
  }

  TGraph *vgr, *igr, *etgr, *tgr;

  vgr = new TGraph(i,time,vdet);
  igr = new TGraph(i,time,idet);
  etgr = new TGraph(i,time,et);
  tgr = new TGraph(i,time,t);

  c6->cd();
  c6->Clear();
  c6->Divide(2,2,0,0);

  c6->cd(1);
  igr->SetMarkerStyle(20);
  igr->SetTitle("detector current vs time");
  igr->Draw("AL");
  igr->GetXaxis()->SetTitle("Time(min)");
  igr->GetYaxis()->SetTitle("Idet(uA)");
  igr->Draw("APL");

  c6->cd(3);
  etgr->SetMarkerStyle(20);
  etgr->SetTitle("amb. temperature vs time");
  etgr->Draw("AL");
  etgr->GetXaxis()->SetTitle("Time(min)");
  etgr->GetYaxis()->SetTitle("Tamb(degC)");
  etgr->Draw("APL");

  c6->cd(2);
  vgr->SetMarkerStyle(20);
  vgr->SetTitle("detector bias vs time");
  vgr->Draw("AL");
  vgr->GetXaxis()->SetTitle("Time(min)");
  vgr->GetYaxis()->SetTitle("Vdet(V)");
  vgr->Draw("APL");

  c6->cd(4);
  tgr->SetMarkerStyle(20);
  tgr->SetTitle("hyb. temperature vs time");
  tgr->Draw("AL");
  tgr->GetXaxis()->SetTitle("Time(min)");
  tgr->GetYaxis()->SetTitle("Thyb(degC)");
  tgr->Draw("APL");

  strun.Close();

  return;
}
