void ind_dat(Int_t run, Int_t scan){

  Int_t i,j,nread,chip,strip;
  Float_t p0,p1,p2,mvthr[13],ngood;
  Float_t *x, *y;
  Double_t occ,occ_ind[128],sno[128];
  Char_t fname[128],title[64],mname[64];
  FILE *ftxt,*rctxt, *out, *out2;
  TGraph *icc,*idd, *occgr;
  TH2F *h_scan;
  TH1F *h_proj;
  TF1* f1;
  f1 = new TF1("f0", "pol0",  0, 128);

  sprintf(fname,"D:\\sctvar\\data\\strun%d_%d.root",run,scan);
  TFile strun(fname);
  sprintf(title,"ModuleName;1");
  TObjString* name = (TObjString*)strun.Get(title);
  if(name){
    if(strcmp(name->GetName(),"missing")){
      sprintf(mname,"%s",name->GetName());
      if(!strcmp("k22",mname))
	sprintf(mname,"0022");
      if(!strcmp("k26",mname))
	sprintf(mname,"0026");
      if(!strcmp("scand2",mname))
	sprintf(mname,"0004");
      sprintf(fname,"J:\\www\\barrel_web\\ind_mod\\%s\\%s_occ.dat",mname,mname);
      out2 = fopen(fname,"w");
    }
    else
      return;
  }
  else
    return;
  sprintf(title,"Icc;1");
  icc = (TGraph*) strun->Get(title)->Clone();
  sprintf(title,"Idd;1");
  idd = (TGraph*) strun->Get(title)->Clone();
  
  mvthr[12] = 0.;
  ngood = 0.;
  sprintf(fname,"D:\\sctvar\\config\\%s.rcdat",mname);
  rctxt = fopen(fname,"r");
  for(j=0;j<6;j++)
    fscanf(rctxt,"%s",title);
  for(j=0;j<12;j++){
    fscanf(rctxt,"%d",&chip);
    if(chip<0 || chip>11){
      printf("ERROR: chip index out of range: %d\n",chip);
      return;
    }
    fscanf(rctxt,"%s",title);
    fscanf(rctxt,"%s",title);
    fscanf(rctxt,"%f",&p0);
    fscanf(rctxt,"%f",&p1);
    fscanf(rctxt,"%f",&p2);
    mvthr[chip] = p2 + p0/(1+ (float)exp(-1./p1));
    if(mvthr[chip]<200.){
      mvthr[12] += mvthr[chip];
      ngood++;
    }
  }
  mvthr[12] /= ngood;
  fclose(rctxt);
  
  x = idd->GetX();
  y = idd->GetY();
  for(j=1;j<idd->GetN()-1;j++){
    if(x[j]<=mvthr[12] && mvthr[12]<x[j+1]) break;
  }
  printf("Idd(1fC) = %.2f\n",(y[j]+y[j+1])/2.);
  
  /*
  sprintf(title,"h_scan0;1");
  h_scan= (TH2F*)strun->Get(title);
  for(chip=0;chip<6;chip++){
    sprintf(title,"h_proj0_%d",chip);
    h_scan->ProjectionY(title,128*chip,127+128*chip);
    h_proj= (TH1F*)gDirectory->GetList()->FindObject(title);
    h_proj->Scale(1.0/128);
    occ = h_proj->GetBinContent(h_proj->GetXaxis()->FindBin(mvthr[chip]));
    fprintf(out2,"%e\n",occ);
  }
  sprintf(title,"h_scan1;1");
  h_scan= (TH2F*)strun->Get(title);
  for(chip=0;chip<6;chip++){
    sprintf(title,"h_proj1_%d",chip);
    h_scan->ProjectionY(title,128*chip,127+128*chip);
    h_proj= (TH1F*)gDirectory->GetList()->FindObject(title);
    h_proj->Scale(1.0/128);
    occ = h_proj->GetBinContent(h_proj->GetXaxis()->FindBin(mvthr[chip+6]));
    fprintf(out2,"%e\n",occ);
  }
  fprintf(out2,"\n");
  */

  sprintf(title,"h_scan0;1");
  h_scan= (TH2F*)strun->Get(title);
  for(chip=0;chip<6;chip++){
    for(strip=0;strip<128;strip++){
      occ_ind[strip] = h_scan->GetBinContent(h_scan->GetBin(strip+128*chip,h_scan->GetYaxis()->FindBin(mvthr[chip])));
      sno[strip] = (Double_t) strip;
    }
    occgr = new TGraph(128,sno,occ_ind);
    occgr->Fit("f0","0Q");
    occ = f1->GetParameter(0);    
    fprintf(out2,"%e\n",occ);
  }
  
  sprintf(title,"h_scan1;1");
  h_scan= (TH2F*)strun->Get(title);
  for(chip=0;chip<6;chip++){
    for(strip=0;strip<128;strip++){
      occ_ind[strip] = h_scan->GetBinContent(h_scan->GetBin(strip+128*chip,h_scan->GetYaxis()->FindBin(mvthr[chip+6])));
      sno[strip] = (Double_t) strip;
    }
    occgr = new TGraph(128,sno,occ_ind);
    occgr->Fit("f0","0Q");
    occ = f1->GetParameter(0);    
    fprintf(out2,"%e\n",occ);
  }
  
  strun.Close();
  fclose(out2);

  return;
}
