Float_t mV2fC(Char_t *mname, Int_t chip, Float_t vthr){
  Char_t fname[128], intxt[32];
  sprintf(fname,"D:\\sctvar\\config\\%s.rcdat",mname);
  Int_t rdchip,func[12],method, nread, i;
  Float_t p[3][12],qthr,vv;

  if(chip<0 || chip>11) return 0.;
  
  FILE* input;
  input = fopen(fname,"r");
  if(!fopen){
    printf("cannot open file %s\n",fname);
    return 0.;
  }

  nread=1;
  for(i=0;i<6&&nread==1;i++)
    fscanf(input,"%s",intxt);

  rdchip=-1;
  while(rdchip<11 && nread==1){
    fscanf(input,"%d",&rdchip);
    fscanf(input,"%d",&method);
    fscanf(input,"%d",func+rdchip);
    for(i=0;i<3 && nread==1; i++)
      fscanf(input,"%f",&(p[i][rdchip]));
    //printf("%d %f %f %f\n",rdchip,p[0][rdchip],p[1][rdchip],p[2][rdchip]);
  }
  
  fclose(input);

  switch(func[chip]){
    case 1: /* polynomial */
    vthr = p[0][chip] + qthr * (p[1][chip] + (qthr * p[2][chip]) );
    break; 
  case 2: /* grillo */
    if((qthr==0)|| (p[1][chip]==0))
      vv = 0;
    else
      vv = p[2][chip] / (p[1][chip] *qthr);
    vthr  = p[0][chip] + p[2][chip] / (float) sqrt(1+(vv*vv)); 
    break; 
  case 3: /* exp */
    qthr = -(float) log(p[0][chip]/(vthr - p[2][chip]) - 1)*p[1][chip];
    break;  
  case 4: /* linear fit */
    if(p[1][chip]==0)
      qthr = 0;
    else
      qthr = (vthr - p[0][chip]) / p[1][chip];
    break; 
  default:
    vthr = 0;
    break;
  }
  return qthr;
}
Float_t mV2fC(Char_t *mname, Float_t vthr){
  Int_t chip;
  Float_t qthr=0.;
  for(chip=0;chip<12;chip++)
    qthr += mV2fC(mname,chip,vthr);
  qthr /= 12.;
  return qthr;
}
