Int_t get_val(char* line, Int_t index, double* val){

  // convert next element of data row "line" to type double
  // (CINT sscanf is limited to <43 elements, hence this approach)

  char substring[20];

  sscanf(line+=index,"%s ",substring);
  sscanf(substring,"%lf",val);
  return 1 + strlen(substring);
}

Int_t dotrim(Float_t vt50[1536][16], Float_t trim[1536], Float_t target){

  Int_t i,j,k,nfail[12];

  k=0;
  for(i=0;i<12;i++) nfail[i]=0;

  for(i=0;i<1536;i++){
    j=15;
    while(j){
     if((vt50[i][j]>=target)&&(vt50[i][j-1]<target)&&(vt50[i][j-1]>0)){
       if((vt50[i][j]-target)<(target-vt50[i][j-1])){
         trim[i]=j; 
       }else{
         trim[i]=j-1;
       }
       j=0;
       k++;
       nfail[i/128]++;
     }else{ 
       j--;
     } 
    }
    if (trim[i]==15) {
//       printf("\ni = %04d",i);
     for(j=0;j<16;j++)
//       printf("%3.0f ",vt50[i][j]);
     if (vt50[i][0] > target) trim[i]=0; 
    }
  }

  for(i=0;i<12;i++) nfail[i]=128 - nfail[i];

  printf("Target %3.0f: Trim %4d: Fail %4d: ",target,k,1536-k);
  printf("%d %d %d %d %d %d %d %d %d %d %d %d\n",
        nfail[0],nfail[1],nfail[2],nfail[3],
        nfail[4],nfail[5],nfail[6],nfail[7],
        nfail[8],nfail[9],nfail[10],nfail[11]);
  return k;
}

void stan_trims(Int_t run, Int_t start_scan, Int_t moi, Float_t target){

  // Second go at a macro to set trimdac levels for ABCDT
  // Version 0.3, PWP, working 25.10.99
  // Version 0.31 PWP 18.01.99 - output list of untrimmed channels

  char f_name[128],line[1024],string[32];
  double mean;
  float vt50[1536][16], trim[1536];
  Int_t index,i,j,loi;

  // Locality options now moved to stan_util.cpp

  // Load other files needed by this one
  gROOT->LoadMacro("stan_util.cpp");

  //  initialise variables

  for(i=0;i<1536;i++){
    trim[i]=15;
    for(j=0;j<16;j++) vt50[i][j]=0;
  }


  // load data

  for(j=0;j<16;j++){
    for(loi=0;loi<2;loi++){
      
      if (RAL) sprintf(f_name,"M:\\sctvar\\data\\strun%d_%d_%d_%d.fit",run,(start_scan+j),moi,loi);
      else     sprintf(f_name,"D:\\sctvar\\data\\strun%d_%d_%d_%d.fit",run,(start_scan+j),moi,loi);
      FILE* fitfile = fopen(f_name,"r");

      if(fitfile==NULL) printf("Could not open fit file %s\n",f_name);
      else {
        printf("File %s opened for reading\n",f_name);

        if(loi) i=768; else i=0;

        fgets(line,1024,fitfile);
        while(fgets(line,1024,fitfile) != NULL){
          index = 10;
          get_val(line,index,&mean);
          vt50[i][j]=(float)mean;
          i++;
        }
      fclose(fitfile);
      }
    }
  }


  // process data

  if(target==-1){ // no target value specified
    Int_t best = 0;
    for(i=0; i<60; i++){
      target = 5*i;
      Int_t ntrimmed=dotrim(vt50, trim, target);
      if(ntrimmed>best){
        best = ntrimmed;
        Float_t best_target = target;
      }
    }
    printf("Best target found to be %3.2f\n",best_target);
    for(i=0;i<1536;i++){
      trim[i]=15;
    }
    dotrim(vt50, trim, best_target);

  }else{
    dotrim(vt50, trim, target);
  }

  // open trim file

  if (RAL) sprintf(f_name,"M:\\sctvar\\data\\stmod_%d.trim",moi);
  else     sprintf(f_name,"D:\\sctvar\\data\\stmod_%d.trim",moi);
  FILE* trimfile = fopen(f_name,"w");
  if(trimfile==NULL){
      printf("Could not open trim file %s\n",f_name);
  } else {
    for(i=0;i<1536;i++){
      fprintf(trimfile,"%f\n", trim[i]/15);
    }
  fclose(trimfile);
  }

  // open channel mask file

  if (RAL) sprintf(f_name,"M:\\sctvar\\data\\stmod_%d.mask",moi);
  else     sprintf(f_name,"D:\\sctvar\\data\\stmod_%d.mask",moi);
  FILE* trimfile = fopen(f_name,"w");
  if(trimfile==NULL){
      printf("Could not open mask file %s\n",f_name);
  } else {
    for(i=0;i<1536;i++){
      if(trim[i]==15)fprintf(trimfile,"%d\n", i);
    }
  fclose(trimfile);
  }
}

void stan_trims(Int_t run, Int_t start_scan, Int_t moi){
  stan_trims(run,start_scan,moi,-1);
}
