void BypassLoop(Float_t startVdd, Float_t stopVdd, Float_t stepVdd) {

  #define MAX_MODULES 2 

  Char_t fname[40];
  Char_t mname[10];

  gROOT->LoadMacro("BypassTest.cpp");

  TDatime *dt = new TDatime;
  Int_t date = dt->GetDate();

  for(Int_t module=0; module<MAX_MODULES; module++){
    e->GetModuleName(module,mname);
    sprintf(fname,"D:\\sctvar\\results\\%s_%d.txt",mname,date);
    FILE* outfile = fopen(fname,"a+");
    if(outfile==NULL){
      printf("Could not open result file %s\n",fname);
      return;
    } else {
      printf("File %s opened to append results \n",fname);

      fprintf(outfile,"%%BypassLoop\n"); 
      fprintf(outfile,"%%Vdd = %3.1f to %3.1f in steps of %3.1f\n",startVdd,stopVdd,stepVdd);
      fprintf(outfile,"#\n");
      
      fprintf(outfile,"\nKey for BypassTest Analysis\n\n");
      fprintf(outfile," '1' > 120 channels/chip returns 98 - 102%% occupancy\n");
      fprintf(outfile," '0' > 120 channels/chip returns -2 - 2%% occupancy\n");
      fprintf(outfile," '2' otherwise\n\n");
 
      fprintf(outfile,"n   C0 C1 C2 C3 C4 C5 C6 C7 C8 C9 C10 C1   L0 L1   M0 M1\n");
      fprintf(outfile,"0   M  E  -  -  -  -  M  E  -  -  -   -    1  1    1  1\n");
      fprintf(outfile,"1   M  S  E  -  -  -  M  S  E  -  -   -    1  1    1  1\n");
      fprintf(outfile,"2   M  S  S  E  -  -  M  S  S  E  -   -    1  1    1  1\n");
      fprintf(outfile,"3   M  S  S  S  E  -  M  S  S  S  E   -    1  1    1  1\n");
      fprintf(outfile,"4   M  S  S  S  S  E  M  S  S  S  S   E    1  1    1  1\n");
      fprintf(outfile,"5   M  X  E  -  -  -  M  X  E  -  -   -    1  1    1  1\n");
      fprintf(outfile,"6   M  S  X  E  -  -  M  S  X  E  -   -    1  1    1  1\n");
      fprintf(outfile,"7   M  S  S  X  E  -  M  S  S  X  E   -    1  1    1  1\n");
      fprintf(outfile,"8   M  S  S  S  X  E  M  S  S  S  X   E    1  1    1  1\n");
      fprintf(outfile,"9   M  S  S  S  S  S  X  S  S  S  S   E    2  0    1  0\n");
      fprintf(outfile,"10  X  S  S  S  S  E  M  S  S  S  S   S    0  2    0  1\n");
      fprintf(outfile,"11  M  S  S  S  S  S  S  S  S  S  S   E    2  0    1  0\n");
      fprintf(outfile,"12  S  S  S  S  S  E  M  S  S  S  S   S    0  2    0  1\n");
    }
    fclose(outfile);
  }

  if(startVdd<stopVdd) {
    
    for(Float_t Vdd=startVdd; Vdd<stopVdd; Vdd+=stepVdd) {
      for(Int_t module=0; module<MAX_MODULES; module++){
	e->GetModuleName(module,mname);
	sprintf(fname,"D:\\sctvar\\results\\%s_%d.txt",mname,date);
	FILE* outfile = fopen(fname,"a+");
	if(outfile==NULL){
	  printf("Could not open result file %s\n",fname);
	  return;
	} else {
	  printf("File %s opened to append results \n",fname);
	  fprintf(outfile,"\n%%Vdd = %4.2f\n\n",Vdd);
	}
	fclose(outfile);
      }
      e->ConfigureVariable(33,Vdd);
      BypassTest(0);
    }

  } else {

    for(Float_t Vdd=startVdd; Vdd>stopVdd; Vdd-=stepVdd) {
      for(Int_t module=0; module<MAX_MODULES; module++){
	e->GetModuleName(module,mname);
	sprintf(fname,"D:\\sctvar\\results\\%s_%d.txt",mname,date);
	FILE* outfile = fopen(fname,"a+");
	if(outfile==NULL){
	  printf("Could not open result file %s\n",fname);
	  return;
	} else {
	  printf("File %s opened to append results \n",fname);
	  fprintf(outfile,"\n%%Vdd = %4.2f\n\n",Vdd);
	}
	fclose(outfile);
      }
      e->ConfigureVariable(33,Vdd);
      BypassTest(0);
    }
  }
}

void BypassLoop() {

  printf("BypassLoop(startVdd, stopVdd, stepVdd)\n");
}














