//
// HybridLTT.cpp   Macro for Long Term Tests of Hybrids
//
// Version 0.1  DGC  17/10/01
// Version 0.2  PWP  12/10/01
// Version 0.3  PWP  26/11/02
//

#ifdef DATA_DIRECTORY
  // do not reload parameters.h
#else
  // must load parameters.h
#include <parameters.h>
#endif

#include "TLTT.h"

void HybridLTT(Int_t small, Int_t big, Int_t total) {

  // Kill background DCS monitor
  st_kill_idle();

  // Creates and does a Hybrid Long Term Test

  gROOT->ProcessLine(".L TLTT.cpp") ;
  TLTT *t = new TLTT(small,big,total) ;
  t->HybridLTT() ;
  delete t;

  // Restart background DCS monitor
  st_set_idle();
}

void HybridLTT() {
  // Current/temperature monitored every 5 min
  // Confirmation Test every 2 hours
  // Characterisation Test at the end
  // Standard duration of test now (7/02) 90 hours

  HybridLTT(300,7200, 90*3600) ;
}
