//
// IVLTT.cpp    Macro for Long Term Tests of Module's Current
//
// Version 0.1  PWP  12/10/01
// Version 0.3  PWP  26/11/02
//

#ifdef DATA_DIRECTORY
  // do not reload parameters.h
#else
  // must load parameters.h
#include <parameters.h>
#endif

#include "TLTT.h"

void IVLTT(Int_t small, Int_t big, Int_t total) {

  // Kill background DCS monitor
  st_kill_idle();

  // Creates and does a Module Long Term Test

  gROOT->ProcessLine(".L TLTT.cpp") ;
  TLTT *t = new TLTT(small,big,total) ;
  t->IVLTT() ;
  delete t;

  // Restart background DCS monitor
  st_set_idle();
}

void IVLTT() {
  // Current/temperature monitored every 5 min
  // (No Confirmation Tests)
  // (No Characterisation Test at the end
  // Standard duration of test 24 hours
  
  IVLTT(60,3600,24*3600) ;
}
