void IddvsVth(int moi, int loi) { // loi = 0 top side, = 1 bottom side, = 2 double sided
  
  // Do the scan
  int start_burst = e->burstnum;
  e->ConfigureScan(1,0,300,2.5);
  e->ConfigureVariable(2,0);
  e->ConfigureVariable(33,4.0);
  st_scan(11,-1);
  int nbursts = e->burstnum - start_burst;

  // Output canvas
  TCanvas *IddCurve = new TCanvas("IddCurve","Idd vs Threshod",400,600);
  if(loi==2) { 
    IddCurve->Divide(1,3);
  } else {
    IddCurve->Divide(1,2);
  }
  IddCurve->cd(1);

  // Find max and min for graph
  float iddmax=0;
  float iddmin=2000;
  for(int i=1;i<nbursts;i++) {
    if( e->m[moi]->idd[i]>iddmax) iddmax = e->m[moi]->idd[i];
    if( e->m[moi]->idd[i]<iddmin) iddmin = e->m[moi]->idd[i];
  }
  printf("iddmax: %f\n",iddmax);
  printf("iddmin: %f\n",iddmin);

  // Draw the current graph
  TGraph *gr = e->LVGetIddGraph(moi);
  TH2F *graph= OpenGraph(0,300,(iddmin-50),(iddmax+50),"Idd vs Threshold","Threshold (mV)","Idd (mA)");
  gr->Draw("CP");
  gr->SetMarkerStyle(21);
  gr->SetMarkerSize(0.3);
  

  // Plot the occupancy
  if(loi==0) {
    TH1D *h_occu = e->m[moi]->h_scan0->ProjectionY("h_occu",0,767);
    IddCurve->cd(2);
    float s_factor=((float)1.0/(float)(768.0*e->burst_ntrigs));
    printf("scale factor= %3.2E\n",s_factor);
    h_occu->Scale(s_factor);
    h_occu->Draw();
    h_occu->SetTitle("Occupancy link 0");
    h_occu->SetXTitle("Threshold (mV)");
    h_occu->SetYTitle("Occupancy");   
  } else if(loi==1) {
    TH1D *h_occu = e->m[moi]->h_scan0->ProjectionY("h_occu",0,767);
    IddCurve->cd(2);
    float s_factor=((float)1.0/(float)(768.0*e->burst_ntrigs));
    printf("scale factor= %3.2E\n",s_factor);
    h_occu->Scale(s_factor);
    h_occu->Draw();
    h_occu->SetTitle("Occupancy link 1");
    h_occu->SetXTitle("Threshold (mV)");
    h_occu->SetYTitle("Occupancy");
 } else {
    TH1D *h_occu0 = e->m[moi]->h_scan0->ProjectionY("h_occu0",0,767);
    IddCurve->cd(2);
    float s_factor=((float)1.0/(float)(768.0*e->burst_ntrigs));
    printf("scale factor= %3.2E\n",s_factor);
    h_occu0->Scale(s_factor);
    h_occu0->Draw();
    h_occu0->SetTitle("Occupancy link 0");
    h_occu0->SetXTitle("Threshold (mV)");
    h_occu0->SetYTitle("Occupancy");   
    TH1D *h_occu1 = e->m[moi]->h_scan1->ProjectionY("h_occu1",0,767);
    IddCurve->cd(3);
    h_occu1->Scale(s_factor);
    h_occu1->Draw();
    h_occu1->SetTitle("Occupancy link 1");
    h_occu1->SetXTitle("Threshold (mV)");
    h_occu1->SetYTitle("Occupancy");   
  }
}

    

TH2F *OpenGraph(Float_t xmin,Float_t xmax,Float_t ymin,Float_t ymax,Char_t *title,Char_t *xtit,Char_t *ytit) {

  TH2F *graph=new TH2F(title,title,2,xmin,xmax,2,ymin,ymax);
  //graph->SetMaximum(ymax);
  //graph->SetMinimum(ymin);
  graph->GetXaxis()->SetTitleSize(0.042);
  graph->SetXTitle(xtit);
  graph->SetYTitle(ytit);
  graph->SetLabelSize(0.04,"X");
  graph->SetLabelSize(0.04,"Y");
  graph->GetXaxis()->SetTitleOffset(0.9);
  graph->GetYaxis()->SetTitleOffset(1.1);
  graph->SetTitleOffset(1.25,"XY");
  graph->Draw();
  return graph;
}






