void KwikGain(Short_t dowait, Short_t postscript){

  // Compatible with KwikGain method (??)
  // version 0.1 PWP 04.10.00
  // version 0.2 LE  15.11.00
  // version 0.3 PWP  15.11.00

  Int_t n_points = 2;
  Int_t special_point = 0;
  Int_t scans[2];
  Float_t charges[2] = {2.00,3.00};

  Short_t fit_type = 4;   // linear fit

  // load the plot macro 
  gROOT->ProcessLine(".L ResponseCurvePlot.cpp");

  // Configure the scan
  e->StOutScanReset();
  e->ascii_nt=0;
  e->abort=0;

  e->do_fits=1;            // integrated fitting ON

  e->burst_trtype = 3;     // CAL + L1A

  if(e->abort==0){
    e->ConfigureVariable(42,charges[0]);  // 42 - QCAL in fC
    e->ConfigureScan(1,0,250,5);
    st_scan(11,-1);
    scans[0]=e->scannum;
  }

  if(e->abort==0){
    e->ConfigureVariable(42,charges[1]);
    e->ConfigureScan(1,0,300,5);
    st_scan(11,-1);
    scans[1]=e->scannum;
  }

  if(e->abort==0){
    ResponseCurvePlot(e->runnum,n_points,special_point,scans,charges,fit_type,dowait,postscript,0);
  }
}

void KwikGain(){

  // if called with no arguments, do not wait between pages of output
  // but still generate the postscript file

  KwikGain(0,1);
}

