void KwikTrimScan(Float_t charge, Int_t graphics, Int_t postscript, Int_t Range){

  //
  // version 0.1 PWP 14.12.00
  // version 0.1 HP 3.4.01 modified for trim range and more trim values
  //             DGC fixed arguments to TrimScanPlot
  //
  
  Int_t n_points = 4;
  Int_t scans[4];
  Float_t trims[4] = {3,7,10,15};
  /*
  Int_t n_points = 2;
  Int_t scans[2];
  Float_t trims[2] = {3,15};
  */
  Short_t method = 0;   // 0 - trim all chips to the same threshold
                        // 1 - trim each chip seperately

  // load the plot macro 
  gROOT->ProcessLine(".L TrimScanPlot.cpp");


  e->StOutScanReset();
  e->ascii_nt=0;
  e->abort=0;

  e->do_cal_loop=1;       // cal loop ON
  e->do_fits=1;           // integrated fitting ON
  e->do_mask_test=0;       // alternating mask patterns OFF 
  e->config_frequency = 0; // do NOT send full configuration before each event

  e->burst_trtype = 3;    // cal + L1A
  e->burst_ntrigs = 25;

  e->ConfigureVariable(11,1);  // X1X compression 
  e->ConfigureVariable(12,Range);  // SET TRIM RANGE = 3
  e->ConfigureVariable(13,0);  // EDGE DETECT OFF
  e->ConfigureVariable(14,0);  // Route Mask OFF
  e->ConfigureVariable(2,charge);  // 2 - VCAL (mV)


  Int_t i;
  for(i=0;i<n_points;i++){

    if(e->abort==0){
      e->ConfigureVariable(6,trims[i]);  // 6 - TrimDAC
      e->ConfigureScan(1,0,300,5);     // 1 - VTHR (mV)

      st_scan(11,-1);

      scans[i]=e->scannum;
    }
  }

  // Reset the TrimDAC and TrimRange values after the scans.
  e->ConfigureVariable(12,0);  // SET TRIM RANGE = 0
  e->ConfigureVariable(6,0);  // TrimDAC = 0

  if(e->abort==0){
    // TrimScanPlot(e->runnum,n_points,method,Range,charge,scans,trims,0,graphics,postscript);
  }
}

void KwikTrimScan(Float_t charge){

  // if called with one argument,
  // do not wait between pages of output
  // but still generate the postscript files

  KwikTrimScan(charge,0,1,3);
}

void KwikTrimScan(){

  // if called with no arguments, use 1fC charge
  // do not wait between pages of output
  // but still generate the postscript files

  KwikTrimScan(10,0,1,3);
}



