void OffsetTrimScan(Float_t charge, Int_t trimrange, Int_t graphics, Int_t postscript){

  //
  // version 0.1 PWP 02.11.00
  // version 0.2 PWP 14.11.00 (bugfix: missing comma!!)
  // version 0.3 PWP 15.11.00
  // version 0.4 PWP 28.11.00
  // version 0.5 PWP 10.12.00
  //

  Int_t n_points = 16;
  Int_t scans[16];
  Float_t trims[16] = {0, 1, 2, 3, 4, 5, 6, 7,
                       8, 9,10,11,12,13,14,15};

  Short_t method = 0;   // 0 - trim all chips to the same threshold
                        // 1 - trim each chip seperately

  // load the plot macro 
  gROOT->ProcessLine(".L OffsetTrimScanPlot.cpp");


  e->StOutScanReset();
  e->ascii_nt=0;
  e->abort=0;

  e->do_cal_loop=1;        // cal loop ON
  e->do_fits=1;            // integrated fitting ON
  e->do_mask_test=0;       // alternating mask patterns OFF 
  e->config_frequency = 0; // do NOT send full configuration before each event

  e->burst_trtype = 0;     // L1A only 
  e->burst_ntrigs = 1000;

  e->ConfigureVariable(11,1);     // X1X compression 
  e->ConfigureVariable(13,0);     // EDGE DETECT OFF
  e->ConfigureVariable(14,0);     // Route Mask OFF
  e->ConfigureVariable(2,charge); // 2 - VCAL (mV)

  if((trimrange<4)&&(trimrange>-1)){
    e->ConfigureVariable(12,trimrange); // 12 - trimrange
  }


  Int_t i;
  for(i=0;i<n_points;i++){

    if(e->abort==0){
      e->ConfigureVariable(6,trims[i]);  // 6 - TrimDAC
      e->ConfigureScan(1,0,300,2.5);     // 1 - VTHR (mV)

      st_scan(11,-1);

      scans[i]=e->scannum;
    }
  }


  if(e->abort==0){
    TrimScanPlot(e->runnum,n_points,method,trimrange,charge,scans,trims,1,graphics,postscript);
  }

  // Make a noise occupancy scan

  gROOT->ProcessLine(".L No.cpp");
  No();
}


void OffsetTrimScan(Float_t charge, Int_t graphics, Int_t postscript){

    //if called without TrimRange expicitly stated.

    OffsetTrimScan(charge,-1,graphics,postscript);
  }

void OffsetTrimScan(Float_t charge){

  // if called with one argument,
  // do not wait between pages of output
  // but still generate the postscript files

  OffsetTrimScan(charge,-1,0,1);
}

void OffsetTrimScan(){

  // if called with no arguments, use 1fC charge
  // do not wait between pages of output
  // but still generate the postscript files

  OffsetTrimScan(0,-1,0,1);
}


