void PipelineTest(Int_t do_restart) { 

  //
  // version 0.2 PWP 13.11.00
  // version 0.3 LE  21.11.00 - resetting values after scan
  // version 0.4 PWP 23.11.00 - replace maxtrigs by ntrigs (oops!!)
  // version 0.5 LE  06.08.01 - scan twice to detect dead and stuck cells.
  //                            (I guess this is the failure mode you are
  //                             refering to?)
  //                          - changing e->burst_maxtrigs=100 to  e->burst_nttorigs = 100;  

  // load the analysis macro 
  gROOT->ProcessLine(".L PipelineAnalysis.cpp");

  //Store settings before the scan
  e->SaveState();

  // Configure the scan
  e->StOutScanReset();
  e->ascii_nt=0;

  e->burst_trtype=35;     // single soft reset, pulse input 
                          // register and L1A using SLOG 

  e->burst_ntrigs = 100;  // LE 07.08.01

  e->ConfigureVariable(11,1);  // X1X compression 
  e->ConfigureVariable(13,0);  // EDGE DETECT OFF
  e->ConfigureVariable(14,0);  // Route Mask to Pipeline      

  // Scan twice, first to detect dead pipeline cells:

  e->ConfigureVariable(7,3);       // No masked channels
  e->ConfigureScan(25,140,151,1);  // 25 - command delay
  st_scan(11,-1);                  // Do the scan

   // Secondly, to find stuck pipeline cells

  e->ConfigureVariable(7,0);       // All channels masked
  e->ConfigureScan(25,140,151,1);  // 25 - command delay
  st_scan(11,-1);                  // Do the scan
 
  // Reset values after scan
  e->RestoreState();

  e->ConfigureVariable(25,200);   // Reset default command delay.

  // NB. During production testing, the "Restart" should be
  // skipped to save time, it takes much longer than the scan
  // itself!!  The mask and trim files need only be loaded
  // prior to the analogue tests PWP 23.11.00

  if(do_restart){
    e->Restart();              // Reload mask and trim files.
  }

  //
  // Call the analysis macro.
  // Arguments are:
  //  run, scan, module
  //

  PipelineAnalysis(e->runnum, (e->scannum-1),-1);
} 

void PipelineTest(){

  // By default, mask and trim files are reloaded
  // after the scan. PWP 23.11.00

  PipelineTest(0);
}

