void RedundancyTest(Int_t do_restart) { 

  //
  // Test both clock/command options
  // also send alternating patterns to the mask register
  //
  // version 0.2 PWP 13.11.00
  // version 0.3 PWP 14.11.00
  // version 0.4 LE  21.11.00 - resetting values after scan.
  // version 0.5 PWP 23.11.00 - cosmetics
  //


  // load the analysis macro 
  gROOT->ProcessLine(".L RedundancyAnalysis.cpp");

  // Store settings before scan
  e->SaveState();

  // Configure the scan
  e->StOutScanReset();
  e->ascii_nt=0;

  e->do_cal_loop=0;        // cal loop OFF
  e->do_fits=0;            // integrated fitting OFF
  e->do_mask_test=1;       // alternating mask patterns ON 
  e->config_frequency = 1; // send full configuration before each event

  e->burst_trtype=31;      // SOFT RESET + (com_delay BCOs) + L1A
  e->burst_ntrigs=100;

  e->ConfigureVariable(11,1);  // X1X compression 
  e->ConfigureVariable(13,0);  // EDGE DETECT OFF
  e->ConfigureVariable(14,1);  // Route Mask to Pipeline      
  e->ConfigureVariable(25,129);  // com delay      


  e->ConfigureScan(38,0,1,1);

  st_scan(11,-1);


  // Reset values after scan
  e->RestoreState();

  e->ConfigureVariable(25,200);  // Reset default command delay      
  e->ConfigureVariable(38,0);    // set SELECT back to 0

  // NB. During production testing, the "Restart" should be
  // skipped to save time, it takes much longer than the scan
  // itself!!  The mask and trim files need only be loaded
  // prior to the analogue tests PWP 23.11.00

  if(do_restart){
    e->Restart();              // Reload mask and trim files.
  }

  //
  // Call the analysis macro.
  // Arguments are:
  //  run, scan, module
  //

  RedundancyAnalysis(e->runnum, e->scannum,-1);
} 

void RedundancyTest(){

  // By default, mask and trim files are reloaded
  // after the scan. PWP 23.11.00

  RedundancyTest(1);
}

