void T7IccVsFEScan(){


  // Save variables to restore afterwards



  // Do the scanning

  e->ConfigureScan(4,50,250,5);

  e->ConfigureVariable(5,20); // Set Ishpr = 20
  st_scan(11,-1);

  Int_t scan = e->scannum;
  Int_t run  = e->runnum;

  e->ConfigureVariable(5,30); // Set Ishpr = 30
  st_scan(11,-1);

  T7PlotIcc(run,scan,1);
}

void T7PlotIcc(Int_t run, Int_t scan, Int_t postscript){

  #ifdef DATA_DIRECTORY
    // do not reload parameters.h
  #else
    // must load parameters.h
  #include <parameters.h>
  #endif

  gROOT->LoadMacro("ToolBox.cpp");

  char f_name1[64],f_name2[64],h_name[64];
  char line[64], mname[MAX_MODULES][32];

  // Untested, due to in TGraph
  Double_t* xdata;
  Double_t* icc20_data;
  Double_t* icc30_data;

  Int_t dowait=1;
  Int_t ps_page=0;
  Int_t screen_page=0;

    
  // Find today's date - needed for file output

  TDatime *dt = new TDatime;
  Int_t date = dt->GetDate();
  Int_t the_time = dt->GetTime();
  delete dt;

  TObjString* time = 0;
  TObjString* place = 0;
  TObjString* name = 0;

  // 
  // Load the Fitted Scan Data
  //

  sprintf(f_name1,"%sstrun%d_%d.root",DATA_DIRECTORY,run,scan);
  sprintf(f_name2,"%sstrun%d_%d.root",DATA_DIRECTORY,run,scan+1);

  TFile *strun20 = new TFile(f_name1);
  TFile *strun30 = new TFile(f_name2);

  if((strun20==0)||(strun30==0)){
    printf("Failed to open file %s or file %s - EXITING!!\n",f_name1,f_name2);
    return;
  }

  //
  // Open the output canvas
  //

  TCanvas*     C_Icc = 0;
  TPostScript* ps    = 0;

  C_Icc= new TCanvas ("C_Icc","IccVsFE",600,400);

  // Find histograms and graphs

  TGraph* icc_20;
  TGraph* icc_30;

  for(Int_t module=0;module<MAX_MODULES;module++){

    icc_20=0;
    icc_30=0;


    sprintf(h_name,"ModuleName;%d",module+1);
    if(time) delete time;
    if(place) delete place;
    if(name) delete name;
    time  = (TObjString*)strun20->Get("Time");
    place = (TObjString*)strun20->Get("Place");
    name = (TObjString*)strun20->Get(h_name);

    if(name) sprintf(mname[module],"%s",name->GetName());
    
    // Find histograms
    sprintf(h_name,"Icc;%d",module+1);
    icc_20 = (TGraph*)strun20->Get(h_name);
    icc_30 = (TGraph*)strun30->Get(h_name);
    
    xdata = icc_20->GetX();
    icc20_data = icc_20->GetY();
    icc30_data = icc_30->GetY();
    
    // proceed only if there is data for either link
    if((icc20_data[0]>0)&&(icc30_data[0]>0)){
      //    if((icc_20)&&(icc_30)&&(mname[module]!="missing")){
      
      if(postscript){
	ps_page=0;
	  sprintf(f_name1,"%s%s_IccVsFE_%d_%06d.ps",PS_DIRECTORY,mname[module],date,the_time);
	  ps = new TPostScript(f_name1,112);
      }
      
      printf("Generating Plots for module %d\n",module);
	
      ps_page++;
      screen_page++;
      if(ps){
	  ps->NewPage();
      }
      
      C_Icc->cd();
      C_Icc->Clear();
      
      TPad *pad_t = new TPad("pad_t","Text",        0.00,0.90,1.00,1.00,33);
      TPad *pad_i = new TPad("pad_i","IccVsFE",     0.00,0.00,1.00,0.90,33);
      
      pad_t->Draw();
      pad_i->Draw();
      
      
      TPaveText *t1 = new TPaveText(0.0,0.0,1.0,1.0);
      t1->SetFillColor(10);
      t1->SetTextAlign(13);
      t1->SetTextSize(0.3);
      t1->SetTextColor(4);
      sprintf(line,"ATLAS SCT Icc versus FE currents");
      if(time)  sprintf(line,"%s  -  %s",line,time->GetName());
      if(place) sprintf(line,"%s  -  %s",line,place->GetName());
      t1->AddText(line);
      
      sprintf(line,"Page %d   Run %d   Scan %d   Module %d (%s)", 
	      ps_page, run, scan, module, mname[module]);
      t1->AddText(line);
      pad_t->cd();
      t1->Draw();
      

      pad_i->cd();
	
      gPad->SetLeftMargin(0.12);
      gPad->SetBottomMargin(0.15);
      icc_20->SetLineColor(kRed);
      icc_30->SetLineColor(kBlue);
      icc_20->SetMarkerColor(kRed);
      icc_30->SetMarkerColor(kBlue);
      
      // Create histograms to draw graphs
      OpenGraph(0,300,200,1200,"IccVsFE","uA","mA");
      
      icc_20->Draw("LP");
      icc_30->Draw("LP");

      pad_i->Update();
      C_Icc->Update();

      if(ps){
        ps->Close();
        delete ps;
      }
      
      if((screen_page>0)&&(dowait)){
	  printf("Enter a string to continue\n");
	  scanf("%s",line);
      }
      
    }
  }

  strun20->Close();
  strun30->Close();

  if(time) delete time;
  if(place) delete place;
  if(name) delete name;
}    
