void ThreePointGain(Short_t dowait, Short_t postscript){

  // version 0.1 PWP 15.10.00
  // version 0.4 PWP 23.11.00
  // version 0.5 PWP 30.05.02 - upload RC when done

  Int_t n_points = 3;
  Int_t special_point = 1;
  Int_t scans[3];
  Float_t charges[3] = {1.50,2.00,2.50};

  Short_t fit_type = 4;   // linear fit

  // load the plot macro 
  gROOT->ProcessLine(".L ResponseCurvePlot.cpp");

  // Save settings before the scan
  e->SaveState();

  // Configure the scan
  e->StOutScanReset();
  e->ascii_nt=0;
  e->abort=0;

  e->do_cal_loop=1;        // cal loop ON
  e->do_fits=1;            // integrated fitting ON

  e->burst_trtype = 3;     // CAL + L1A
  e->burst_ntrigs = 1000;

  e->ConfigureVariable(11,1);  // X1X compression 
  e->ConfigureVariable(13,0);  // EDGE DETECT OFF
  e->ConfigureVariable(14,0);  // Route Mask OFF


  if(e->abort==0){
    e->ConfigureVariable(42,charges[0]);  // 42 - QCAL in fC
    e->ConfigureScan(1,0,250,5);
    st_scan(11,-1);
    scans[0]=e->scannum;
  }

  if(e->abort==0){
    e->ConfigureVariable(42,charges[1]);
    e->ConfigureScan(1,0,300,5);
    st_scan(11,-1);
    scans[1]=e->scannum;
  }

  if(e->abort==0){
    e->ConfigureVariable(42,charges[2]);
    e->ConfigureScan(1,50,350,5);
    st_scan(11,-1);
    scans[2]=e->scannum;
  }

  // Restore settings
  e->RestoreState();

  if(e->abort==0){
    ResponseCurvePlot(e->runnum,n_points,special_point,scans,charges,fit_type,dowait,postscript,1);
  }
}

void ThreePointGain(){

  // if called with no arguments, do not wait between pages of output
  // but still generate the postscript file

  ThreePointGain(0,1);
}

