// Parameters.h
// version 2 PWP 18.01.02
// revised PWP 21.03.02

// Define software version

#define ANALYSIS_VERSION "3.31"

// Define Location Name

#define LOCATION_NAME      "UNKNOWN"

// Define file system paths

// Linux
//#define DATA_DIRECTORY     "../sctvar/data/"
//#define RESULTS_DIRECTORY  "../sctvar/results/"
//#define PS_DIRECTORY       "../sctvar/ps/"
//#define UPLOAD_DIRECTORY   "../sctvar/upload/"

// Windows
#define DATA_DIRECTORY     "D:\\sctvar\\data\\"
#define RESULTS_DIRECTORY  "D:\\sctvar\\results\\"
#define PS_DIRECTORY       "D:\\sctvar\\ps\\"
#define UPLOAD_DIRECTORY   "D:\\sctvar\\upload\\"

// The option has been added to put web links into the results file,
// and hence into the SCT DB, to provide direct links to postscript
// files stored on the user's own web server.  Since the hierarchy
// of the user's filesystem may be complex, it is envisaged that 
// the link will point to a script, which will know where to look
// to find the requested plot.  WEB_KEY should be defined up to the
// point at whihc the filename of the plot is added.  For plots 
// stored at RAL this leads to the following key:
//
//#define WEB_KEY "http://hepunx.rl.ac.uk/atlassct/cgibin/getfile.pl?file="
//
// A simpler but less managable option would be to point at a
// directory containing all the files, eg.
//
//#define WEB_KEY "http://myserver/myfolder/"
//
// PWP 21.03.02

// Define analysis parameters

  #define MAX_RANGES     4  // Number of TrimRange settings
  #define MAX_POINTS    16  // Number of TrimDAC points studied for each setting
  #define MAX_MODULES    6 
  #define MAX_LINKS      2
  #define MAX_CHIPS      6
  #define MAX_CHANS    768 
  #define MAX_TARGETS  128
  #define MAX_TRIGGERS 100  // Number of triggers used in digital tests
  #define MAX_PIPELINE  12

  // #define MAX_MUSTARDS  2  // Why were these added to this file?
  // #define MAX_STREAMS  12  // PWP 12.06.01


  #define CH_LOST        0x1003  // dead, stuck or unbonded
  #define CH_DODGY       0xC004  // inefficient, partbonded, or high noise

  #define CH_OK          0x0000  
  #define CH_DEAD        0x0001
  #define CH_STUCK       0x0002
  #define CH_INEFFICIENT 0x0004
  #define CH_LO_GAIN     0x0100
  #define CH_HI_GAIN     0x0200
  #define CH_LO_OFFSET   0x0400
  #define CH_HI_OFFSET   0x0800
  #define CH_UNBONDED    0x1000
  #define CH_LO_NOISE    0x2000
  #define CH_HI_NOISE    0x4000
  #define CH_PARTBONDED  0x8000

  #define MIN_NO         1e-6
  #define MAX_NO         2e-4

