void CalInj(Int_t modinj, Int_t chipinj, Int_t tottrg, Float_t cal_chg, Float_t thr_chg) { 

  #ifdef DATA_DIRECTORY
    // do not reload parameters.h
  #else
    // must load parameters.h
  #include <parameters.h>
  #endif

  #define TRG_BST   25000

  Int_t i,j,round,towait,n_bursts,scan_f,scan_l,ntrig, response, t_HVupdate;
  char line[1024],h_name[64],h_title[64],f_name[128];
  TDatime* dt = new TDatime(); // MEMORY LEAK???

  // init for accumulated bursts
  n_bursts = (Int_t) tottrg/TRG_BST;
  gROOT->ProcessLine(".L systest/AccumBursts.cpp");
  gROOT->ProcessLine(".L systest/DCSSafety.cpp");

  //Store settings before the scan
  e->SaveState();

  // Configure the scan
  e->StOutScanReset();
  e->ascii_nt=0;

  e->do_cal_loop=0;       // cal loop OFF
  e->do_fits=0;           // integrated fitting OFF
  e->do_vary_ntrigs=0;    // don't increase number of triggers

  e->burst_trtype=3;      // single L1A+CAL
  e->burst_type = 1;      // simple trigger burst
  e->burst_ntrigs=TRG_BST;

  e->ConfigureVariable(11,1);       // X1X compression 
  e->ConfigureVariable(13,0);       // EDGE DETECT OFF
  e->ConfigureVariable(41,thr_chg); // set Qthr
  // charge injection settings
  e->ConfigureVariable(10,0);       // set CAL-line-ID to first set
  e->ConfigureVariable(42,0.);      // set Qcal for all modules
  e->ConfigureVariable(modinj, chipinj,42,cal_chg); // set Qcal for requested chip

  e->cc->periodic_sr=0;
  e->cc->periodic_bcr=0;
  e->cc->randomiser=0;
  e->cc->SetPeriodicFreq((double)75.0); // trigger frequency in kHz

  e->ExecuteConfigs();

  // start stop/abort panel
  st_start_stopper();
  // Accumulated Bursts
  ntrig = AccumBursts(n_bursts);
  // remove stop/abort panel
  st_stop_stopper();

  // Reset values after scan
  e->RestoreState();

  printf("\nFinished...............\n\n");

}
