void DCS_NOvsT(Int_t run, Int_t firstscan, Int_t lastscan, Int_t dops=1){

  #ifdef DATA_DIRECTORY
    // do not reload parameters.h
  #else
    // must load parameters.h
  #include <parameters.h>
  #endif

  #ifndef MAX_SCANS
    #define MAX_SCANS  1000
  #endif

  TDatime *dt = new TDatime;
  Int_t date = dt->GetDate();
  Int_t i, j, scan, tsec=0, tfirst, nmod, ngood;
  Float_t max_n=1800., min_n=1000., data;
  Color_t col;
  Char_t line[1024],h_title[64],f_name[128];
  Double_t avg;
  Double_t idet[MAX_MODULES][MAX_SCANS], idet1d[MAX_SCANS], tpoints[MAX_SCANS];
  Double_t icc[MAX_MODULES][MAX_SCANS], icc1d[MAX_SCANS];
  Double_t idd[MAX_MODULES][MAX_SCANS], idd1d[MAX_SCANS];
  Double_t t1[MAX_MODULES][MAX_SCANS], t11d[MAX_SCANS], tpoints2[MAX_SCANS];
  Double_t t2[MAX_MODULES][MAX_SCANS], t21d[MAX_SCANS], tmax,tmin;
  Double_t et1[MAX_SCANS], dew[MAX_SCANS];
  Double_t et2[MAX_SCANS], hum[MAX_SCANS];
  char mname[MAX_MODULES][32],a[10],b[10],c[10],d[10],timestr[10];
  Int_t tsec, nread, tstart,tend, npts;
  Char_t texta[1024];
  char mname2[MAX_MODULES][32], drive[32];
  TPostScript *ps;

  gROOT->ProcessLine(".L strtosec.cpp");

  if(lastscan-firstscan>=MAX_SCANS){
    printf("ERROR: too many scans, only up to %d is possible\n",MAX_SCANS);
    return;
  }

  // open canvas
  TCanvas* c6= new TCanvas ("c6","DCS2",1100,750);

  for(scan=0;scan<lastscan-firstscan+1;scan++){
    // open root file
    sprintf(f_name,"%sstrun%d_%d.root",DATA_DIRECTORY,run,scan+firstscan);
    TFile *strun = new TFile(f_name);
    if(!strun){
      printf("can't open file %s\n",f_name);
      return;
    }
    TObjString* time  = (TObjString*)strun->Get("Time");
    TObjString* place = (TObjString*)strun->Get("Place");
    sscanf(time->GetName(), "%s %s %s %s %s",a,b,c,timestr,d);
    tsec = strtosec(timestr);
    if(scan==0) tfirst=tsec;
    tpoints[scan] = ((Double_t)(tsec-tfirst))/3600.;
    nmod=0;
    for (i=0; i<MAX_MODULES; i++){
      sprintf(h_title,"ModuleName;%d",i+1);
      TObjString* name = (TObjString*)strun->Get(h_title);
      if(name){
	if(strcmp(name->GetName(),"missing")){
	  sprintf(mname[nmod],"%s",name->GetName());
	  nmod++;
	  sprintf(h_title,"IDET;%d",i+1);
	  TObjString* sidet = (TObjString*)strun->Get(h_title);
	  if(sidet){  // new software
	    sscanf(sidet->GetName(),"%lf",&(idet[i][scan]));
	    sprintf(h_title,"ICC;%d",i+1);
	    TObjString* sicc = (TObjString*)strun->Get(h_title);
	    sscanf(sicc->GetName(),"%lf",&(icc[i][scan]));
	    sprintf(h_title,"IDD;%d",i+1);
	    TObjString* sidd = (TObjString*)strun->Get(h_title);
	    sscanf(sidd->GetName(),"%lf",&(idd[i][scan]));
	    sprintf(h_title,"T0;%d",i+1);
	    TObjString* st1 = (TObjString*)strun->Get(h_title);
	    sscanf(st1->GetName(),"%lf",&(t1[i][scan]));
	    sprintf(h_title,"T1;%d",i+1);
	    TObjString* st2 = (TObjString*)strun->Get(h_title);
	    sscanf(st2->GetName(),"%lf",&(t2[i][scan]));
	  }
	  else{  // old software
	    sprintf(h_title,"Idet;%d",i+1);
	    TObjString* sidet = (TObjString*)strun->Get(h_title);
	    sscanf(sidet->GetName(),"%lf",&(idet[i][scan]));
	    sprintf(h_title,"Icc;%d",i+1);
	    TObjString* sicc = (TObjString*)strun->Get(h_title);
	    sscanf(sicc->GetName(),"%lf",&(icc[i][scan]));
	    sprintf(h_title,"Idd;%d",i+1);
	    TObjString* sidd = (TObjString*)strun->Get(h_title);
	    sscanf(sidd->GetName(),"%lf",&(idd[i][scan]));
	    sprintf(h_title,"T1;%d",i+1);
	    TObjString* st1 = (TObjString*)strun->Get(h_title);
	    sscanf(st1->GetName(),"%lf",&(t1[i][scan]));
	    sprintf(h_title,"T2;%d",i+1);
	    TObjString* st2 = (TObjString*)strun->Get(h_title);
	    sscanf(st2->GetName(),"%lf",&(t2[i][scan]));
	  }
	  if(i==0){
	    sprintf(h_title,"ET1;1");
	    TObjString* set1 = (TObjString*)strun->Get(h_title);
	    if(set1){
	      sscanf(set1->GetName(),"%lf",&(et1[scan]));
	      sprintf(h_title,"ET2;1");
	      TObjString* set2 = (TObjString*)strun->Get(h_title);
	      sscanf(set2->GetName(),"%lf",&(et2[scan]));
	      sprintf(h_title,"PIPE;1");
	      TObjString* set2 = (TObjString*)strun->Get(h_title);
	      sscanf(set2->GetName(),"%lf",&(dew[scan]));
	      sprintf(h_title,"HUM;1");
	      TObjString* set2 = (TObjString*)strun->Get(h_title);
	      sscanf(set2->GetName(),"%lf",&(hum[scan]));
	    }
	  }
	}
      }
    }
    strun->Close();
  }

  // plot results

  if(dops){
    sprintf(f_name,"%sDCSvsT_%d_%d-%d.ps",PS_DIRECTORY,run,firstscan,lastscan);
    ps = new TPostScript(f_name,112);
  }
  for(i=0;i<nmod;i++){
    if(dops) ps->NewPage();
    c6->cd();
    c6->Clear();
    pad_text   = new TPad("pad_text", "Text",        0.00,0.90,1.00,1.00);
    pad_plot   = new TPad("pad_plot", "Plots",       0.00,0.00,1.00,0.90);
    pad_text->Draw();
    pad_plot->Draw();
    pad_plot->Divide(2,2,0,0);
    c6->Update();
    pad_text->cd();
    TPaveText *txt = new TPaveText(0.0,0.0,1.0,1.0);
    txt->SetFillColor(10);
    txt->SetTextAlign(13);
    txt->SetTextSize(0.3);
    txt->SetTextColor(4);
    sprintf(line,"ATLAS SCT: DCS Readings");
    if(time)  sprintf(line,"%s  -  %s",line,time->GetName());
    if(place) sprintf(line,"%s  -  %s",line,place->GetName());
    txt->AddText(line);
    sprintf(line,"Run %d   Scans %d-%d Module %s", run,firstscan, lastscan,mname[i]);
    txt->AddText(line);
    txt->Draw();
    c6->Update();
    ngood = 0;
    avg=0.;
    for(j=0;j<scan;j++){
      if(idet[i][j]<5000.){
	avg += idet[i][j];
	ngood++;
      }
    }
    avg/=(Double_t)ngood;
    ngood=0;
    tmax=-999.;
    tmin=999.;
    for(j=0;j<scan;j++){
      if(idet[i][j]<1.3*avg && idet[i][j]>0.01){
	//if(idet[i][j]<1.3*avg && idet[i][j]>0.8*avg){
	idet1d[ngood] = idet[i][j];
	tpoints2[ngood] = tpoints[j];
	ngood++;
      }
      if(ngood==0){
	idet1d[0] = idet[i][0];
	tpoints2[0] = tpoints[0];
	ngood++;
      }
      icc1d[j]  = icc[i][j];
      idd1d[j]  = idd[i][j];
      t11d[j]   = t1[i][j];
      if(t1[i][j]>tmax) tmax = t1[i][j];
      if(t1[i][j]<tmin && t1[i][j]!=-128) tmin = t1[i][j];
      t21d[j]   = t2[i][j];
      if(t2[i][j]>tmax) tmax = t2[i][j];
      if(t2[i][j]<tmin && t2[i][j]!=-128) tmin = t2[i][j];
    }
    tmax *= 1.1;
    tmin *= 0.9;
    TGraph *grdt=new TGraph(ngood,tpoints2,idet1d);
    TGraph *grcc=new TGraph(scan,tpoints,icc1d);
    TGraph *grdd=new TGraph(scan,tpoints,idd1d);
    TGraph *grt1=new TGraph(scan,tpoints,t11d);
    TGraph *grt2=new TGraph(scan,tpoints,t21d);
    grdt->SetMarkerStyle(20);
    grdt->SetMarkerSize(1);
    grdt->SetMarkerColor((Color_t) 1);
    grdt->SetTitle("Idet vs Time");
    grcc->SetMarkerStyle(20);
    grcc->SetMarkerSize(1);
    grcc->SetMarkerColor((Color_t) 2);
    grcc->SetTitle("Icc vs Time");
    grdd->SetMarkerStyle(20);
    grdd->SetMarkerSize(1);
    grdd->SetMarkerColor((Color_t) 3);
    grdd->SetTitle("Idd vs Time");
    grt1->SetMarkerStyle(20);
    grt1->SetMarkerSize(1);
    grt1->SetMarkerColor((Color_t) 4);
    grt1->SetTitle("T vs Time");
    grt1->SetMinimum(tmin);
    grt1->SetMaximum(tmax);
    grt2->SetMarkerStyle(24);
    grt2->SetMarkerSize(1);
    grt2->SetMarkerColor((Color_t) 7);
    grt2->SetTitle("T vs Time");
    pad_plot->cd(1);
    grdt->Draw("AP");
    grdt->GetXaxis()->SetTitle("Time(h)");
    grdt->GetYaxis()->SetTitle("I_{det}(#muA)");
    grdt->GetYaxis()->SetTitleOffset(1.3);
    grdt->Draw("AP");
    pad_plot->cd(2);
    grcc->Draw("AP");
    grcc->GetXaxis()->SetTitle("Time(h)");
    grcc->GetYaxis()->SetTitle("I_{cc}(mA)");
    grcc->GetYaxis()->SetTitleOffset(1.2);
    grcc->Draw("AP");
    pad_plot->cd(3);
    grdd->Draw("AP");
    grdd->GetXaxis()->SetTitle("Time(h)");
    grdd->GetYaxis()->SetTitle("I_{dd}(mA)");
    grdd->GetYaxis()->SetTitleOffset(1.2);
    grdd->Draw("AP");
    pad_plot->cd(4);
    grt1->Draw("AP");
    grt1->GetXaxis()->SetTitle("Time(h)");
    grt1->GetYaxis()->SetTitle("T_{1/2}(^{o}C)");
    grt1->Draw("AP");
    grt2->Draw("P");
    c6->Update();
  }

  if(set1){
    c6->cd();
    c6->Clear();
    pad_text   = new TPad("pad_text", "Text",        0.00,0.90,1.00,1.00);
    pad_plot   = new TPad("pad_plot", "Plots",       0.00,0.00,1.00,0.90);
    pad_text->Draw();
    pad_plot->Draw();
    pad_plot->Divide(2,2,0,0);
    c6->Update();
    pad_text->cd();
    TPaveText *txt = new TPaveText(0.0,0.0,1.0,1.0);
    txt->SetFillColor(10);
    txt->SetTextAlign(13);
    txt->SetTextSize(0.3);
    txt->SetTextColor(4);
    sprintf(line,"ATLAS SCT: DCS Readings");
    if(time)  sprintf(line,"%s  -  %s",line,time->GetName());
    if(place) sprintf(line,"%s  -  %s",line,place->GetName());
    txt->AddText(line);
    sprintf(line,"Run %d   Scans %d-%d  -  Ambient Readings", run,firstscan, lastscan);
    txt->AddText(line);
    txt->Draw();
    c6->Update();
    TGraph *gret1=new TGraph(scan,tpoints,et1);
    TGraph *gret2=new TGraph(scan,tpoints,et2);
    TGraph *grdew=new TGraph(scan,tpoints,dew);
    TGraph *grhum=new TGraph(scan,tpoints,hum);
    gret1->SetMarkerStyle(20);
    gret1->SetMarkerSize(1);
    gret1->SetMarkerColor((Color_t) 1);
    gret1->SetTitle("Tamb1 vs Time");
    gret2->SetMarkerStyle(20);
    gret2->SetMarkerSize(1);
    gret2->SetMarkerColor((Color_t) 2);
    gret2->SetTitle("Tamb2 vs Time");
    grdew->SetMarkerStyle(20);
    grdew->SetMarkerSize(1);
    grdew->SetMarkerColor((Color_t) 1);
    grdew->SetTitle("Tpipe vs Time");
    grhum->SetMarkerStyle(20);
    grhum->SetMarkerSize(1);
    grhum->SetMarkerColor((Color_t) 2);
    grhum->SetTitle("Rel. Hum. vs Time");
    pad_plot->cd(1);
    gret1->Draw("AP");
    gret1->GetXaxis()->SetTitle("Time(h)");
    gret1->GetYaxis()->SetTitle("T_{amb1}(^{o}C)");
    gret1->GetYaxis()->SetTitleOffset(1.2);
    gret1->Draw("AP");
    pad_plot->cd(2);
    gret2->Draw("AP");
    gret2->GetXaxis()->SetTitle("Time(h)");
    gret2->GetYaxis()->SetTitle("T_{amb2}(^{o}C)");
    gret2->GetYaxis()->SetTitleOffset(1.2);
    gret2->Draw("AP");
    pad_plot->cd(3);
    grdew->Draw("AP");
    grdew->GetXaxis()->SetTitle("Time(h)");
    grdew->GetYaxis()->SetTitle("T_{pipe}(^{o}C)");
    grdew->GetYaxis()->SetTitleOffset(1.2);
    grdew->Draw("AP");
    pad_plot->cd(4);
    grhum->Draw("AP");
    grhum->GetXaxis()->SetTitle("Time(h)");
    grhum->GetYaxis()->SetTitle("Humidity (%)");
    grhum->GetYaxis()->SetTitleOffset(1.2);
    grhum->Draw("AP");
  }
  
  if(dops) ps->Close();

  return;
}
