void NOQscan(Int_t run, Int_t scan){

  #ifdef DATA_DIRECTORY
    // do not reload parameters.h
  #else
    // must load parameters.h
  #include <parameters.h>
  #endif

  Int_t i, nbins, link, chip, ngood, ngood2, nmod, nsum, nread, id,newlog;
  Float_t x[200],y[200], x2[200],y2[200], content, qthr, evcnt, dy[200],dy2[200],dx[200];
  Float_t en[MAX_MODULES*MAX_CHIPS*MAX_LINKS],qn[MAX_MODULES*MAX_CHIPS*MAX_LINKS],chipid[MAX_MODULES*MAX_CHIPS*MAX_LINKS];
  Float_t mvthr,data,dummy;
  char h_name[32], line[1024],mname[MAX_MODULES][32];
  Char_t texta[1024],textb[1024],dbasedir[128];
  TH1F *tmp=0, *hevcnt=0;
  TH2F *hscan0=0, *hscan1=0;
  TCanvas* c3 =0;
  TObjString *name. *time, *place;
  TGraphErrors *gr[12]={0,0,0,0,0,0,0,0,0,0,0,0}, *gr2[12]={0,0,0,0,0,0,0,0,0,0,0,0};
  FILE *input,*output;

  c3= new TCanvas ("c3","NO",1100,750);

  gROOT->LoadMacro("stan_util.cpp");
  gROOT->LoadMacro("ToolBox.cpp");
  gROOT->LoadMacro("mV2fC.cpp");
  gROOT->LoadMacro("fC2mV.cpp");
  //gROOT->LoadMacro("PosProjY.cpp");
  gROOT->LoadMacro("estand_secind_data.cpp");

  if(strncmp(gSystem->GetName(),"Unix",4))
    sprintf(dbasedir,"J:\\public\\refdat\\");
  else
    sprintf(dbasedir,"~/public/refdat/");

  sprintf(line,"%sNOQscan%d_%d.ps",PS_DIRECTORY,run,scan);
  ps = new TPostScript(line,112);

  TFile* strun;
  sprintf(line,"%sstrun%d_%d.root",DATA_DIRECTORY,run,scan);
  strun = new TFile(line);

  sprintf(line,"%sNOQscan_sum%d_%d.txt",RESULTS_DIRECTORY,run,scan);
  output = fopen(line,"w");

  TF1* f1;
  sprintf(h_name,"f1");
  f1 = new TF1(h_name, "pol1",  0, 3);
  
  nmod = 0;
  nsum = 0;
  for(id=0;id<MAX_MODULES;id++){

    sprintf(h_name,"h_scan0;%d",id+1);
    if(hscan0) hscan0->Delete();
    hscan0 = (TH2F*)strun->Get(h_name);
    sprintf(h_name,"h_scan1;%d",id+1);
    if(hscan1) hscan1->Delete();
    hscan1 = (TH2F*)strun->Get(h_name);
    sprintf(h_name,"h_scan_evcnt;1");
    if(hevcnt) hevcnt->Delete();
    hevcnt = (TH1F*)strun->Get(h_name);
    
    sprintf(h_name,"ModuleName;%d",id+1);
    if(id==0){
      time  = (TObjString*)strun->Get("Time");
      place = (TObjString*)strun->Get("Place");
    }
    name = (TObjString*)strun->Get(h_name);
    if(name)
      sprintf(mname[id],"%s",name->GetName());
    else
      break;
    if(!strcmp(mname[id],"missing")) break;

    nmod++;

    ps->NewPage();
    c3->cd();
    c3->Clear();
    
    pad_t = new TPad("pad_t","Text",        0.00,0.90,1.00,1.00);
    pad_p = new TPad("pad_p","Projections",   0.00,0.00,1.00,0.90);
    pad_t->Draw();
    pad_p->Draw();
    pad_p->Divide(4,3,0,0);
    
    TPaveText *t1 = new TPaveText(0.0,0.0,1.0,1.0);
    t1->SetFillColor(10);
    t1->SetTextAlign(13);
    t1->SetTextSize(0.3);
    t1->SetTextColor(4);
    sprintf(line,"ATLAS SCT Noise Occupancy");
    sprintf(line,"%s  -  log n.o. vs Qthr2",line);
    if(time)  sprintf(line,"%s  -  %s",line,time->GetName());
    if(place) sprintf(line,"%s  -  %s",line,place->GetName());
    t1->AddText(line);
    
    sprintf(line,"Run %d   Scan %d   Module %d (%s)", run, scan, id, mname[id]);
    t1->AddText(line);
    pad_t->cd();
    t1->Draw();
    
    pad_p->cd();
    for(link=0;link<MAX_LINKS;link++){
      for(chip=0;chip<MAX_CHIPS;chip++){
	if(tmp) tmp->Delete();
	if(link==0)
	  tmp = (TH1F*) hscan0->ProjectionY("tmp",chip*128,(chip+1)*128-1);
	//tmp = (TH1F*) PosProjY(hscan0,chip*128,(chip+1)*128-1);
	else
	  tmp = (TH1F*) hscan1->ProjectionY("tmp",chip*128,(chip+1)*128-1);
	//tmp = (TH1F*) PosProjY(hscan1,chip*128,(chip+1)*128-1);
	tmp->Scale(1.0/128);
	nbins = tmp->GetNbinsX();
	ngood=0;
	ngood2=0;
	for(i=0;i<nbins;i++){
	  content = (Float_t) tmp->GetBinContent(i+1);
	  evcnt = (Float_t) hevcnt->GetBinContent(i+1);
	  if(evcnt<1) evcnt=1;
	  qthr = tmp->GetBinCenter(i+1);
	  mvthr = (Float_t) fC2mV(mname[id],chip+6*link,(Float_t) qthr);
	  /* 2.5mV  DAC bit */
	  mvthr = (Float_t) ((int)(((float)mvthr+1.25)/(float)2.5)) * (float)2.5;
	  qthr = (Float_t) mV2fC(mname[id],chip+6*link,(Float_t) mvthr);
	  if(qthr>0.0){ 
	    if(content>5e-9){
	      x[ngood] = qthr*qthr;
	      y[ngood] = TMath::Log(content);
	      dx[ngood] = 0.;
	      //dy[ngood] = (1+(evcnt*content))*(1+(evcnt-(evcnt*content))) / evcnt;
	      dy[ngood] = TMath::Sqrt((1-content)/evcnt/content/128.);
	      //y[ngood] = content;
	      ngood++;
	    }
	    else
	      break;
	    if(qthr>0.5){ 
	      x2[ngood2] =  x[ngood-1];
	      y2[ngood2] =  y[ngood-1];
	      dy2[ngood2] = dy[ngood-1];
	      ngood2++;
	    }
	  }
	}
	
	if(ngood>0 && ngood2 >0) {  
	  if(gr[link*MAX_CHIPS+chip])  gr[link*MAX_CHIPS+chip]->Delete();
	  if(gr2[link*MAX_CHIPS+chip]) gr2[link*MAX_CHIPS+chip]->Delete();
	  gr[link*MAX_CHIPS+chip] = new TGraphErrors(ngood,x,y,dx,dy);
	  gr2[link*MAX_CHIPS+chip] = new TGraphErrors(ngood2,x2,y2,dx,dy2);
	  pad_p->cd((link*6)+chip+1);
	  
	  sprintf(h_name,"Noise Occupancy link %d chip %d", link, chip);
	  gr[link*MAX_CHIPS+chip]->SetTitle(h_name);
	  gr[link*MAX_CHIPS+chip]->SetMarkerStyle(20);
	  gr[link*MAX_CHIPS+chip]->SetMarkerSize(1);
	  gr[link*MAX_CHIPS+chip]->SetMarkerColor((Color_t) 1);
	  gr[link*MAX_CHIPS+chip]->SetMinimum(-20);
	  gr[link*MAX_CHIPS+chip]->SetMaximum(0.5);
	  gr[link*MAX_CHIPS+chip]->Draw("AP");
	  gr[link*MAX_CHIPS+chip]->GetXaxis()->SetTitle("Qthr2, fC^2");
	  gr[link*MAX_CHIPS+chip]->GetYaxis()->SetTitle("Ln(occupancy)");
	  gr[link*MAX_CHIPS+chip]->Draw("AP");
	  gr2[link*MAX_CHIPS+chip]->SetMarkerStyle(1);
	  gr2[link*MAX_CHIPS+chip]->SetMarkerSize(1);
	  gr2[link*MAX_CHIPS+chip]->SetMarkerColor((Color_t) 1);
	  f1->SetLineColor((Color_t) 2);
	  gr2[link*MAX_CHIPS+chip]->Fit("f1","");
	  gr2[link*MAX_CHIPS+chip]->Draw("P");
	  qn[nsum]     = 1./TMath::Sqrt(-2.*f1->GetParameter(1))/1.6e-4;
	  chipid[nsum] = 0.5+(Float_t) chip+MAX_CHIPS*link+id*MAX_CHIPS*MAX_LINKS;
	  sprintf(h_name,"fitted %.0f ENC",qn[nsum]);
	  fprintf(output,"%s\t%.1f\n",mname[id],qn[nsum]);
	  TText t;
	  t.SetTextSize(0.07);
	  t.DrawText(x[ngood-1]*.55,-2,h_name);
	  nsum++;
	}
      }
    }
    
    c3->Update();
    
    // read test stand data
    
    sprintf(line,"%s%s.dat",dbasedir,mname[id]);
    input=fopen(line,"r");
    if(!input){
      printf("cannot open file %s\n",line);
      for(chip=0;chip<12;chip++)
	en[id*MAX_CHIPS*MAX_LINKS+chip] = 0.;
    } else{
      nread=2;
      for(chip=0;chip<12 && nread==2;chip++){
	nread = fscanf(input,"%f %f",&data,&dummy);
	if(nread!=2) data = 0.; 
	en[id*MAX_CHIPS*MAX_LINKS+chip] = data;
      }
      fclose(input);
    }

      /*
    estand_secind_data(1,mname[id],line);
    if(strncmp(gSystem->GetName(),"Unix",4))
      sprintf(line,"%s%s\\%s",dbasedir,mname[id],line);
    else
      sprintf(line,"%s%s/%s",dbasedir,mname[id],line);
    printf("Opening file %s\n",line);
    input=fopen(line,"r");
    if(!input){
      printf("cannot open e-stand data-file %s\n",line);
      for(chip=0;chip<12;chip++)
	en[id*MAX_CHIPS*MAX_LINKS+chip] = 0.;
    } else{
      nread=1;
      chip=-1;
      newlog = 0;
      while(nread==1 && chip<11){
	strcpy(textb,texta);
	nread = fscanf(input,"%s",texta);
	if((!strcmp(texta,"Chip") || !strcmp(texta,"#M0") || newlog==2) 
	   && (!strcmp(textb,"innse_err") || !strcmp(textb,"innse") || !strcmp(textb,"comment") 
	       || !strcmp(textb,"rms") || (chip<11 && chip>=0))){
	  if(!strcmp(textb,"comment")) newlog=1;
	  if(!strcmp(textb,"rms")) newlog=2;
	  if(newlog<2)
	    nread = fscanf(input,"%d:",&chip);
	  else
	    chip++;
	//	if(!strcmp(texta,"Chip") && (!strcmp(textb,"innse_err") || !strcmp(textb,"innse") || !strcmp(textb,"comment") 
	//		     || (chip<11 && chip>=0))){
	//if(!strcmp(textb,"comment")) newlog=1;
	//nread = fscanf(input,"%d:",&chip);
	  nread = fscanf(input,"%s",texta);
	  nread = fscanf(input,"%s",texta);
	  nread = fscanf(input,"%s",texta);
	  nread = fscanf(input,"%s",texta);
	  nread = fscanf(input,"%s",texta);
	  if(newlog){
	    nread = fscanf(input,"%s",texta);
	    nread = fscanf(input,"%s",texta);
	  }
	  nread = fscanf(input,"%f",&data);
	  if(chip>=0 && chip<MAX_CHIPS*MAX_LINKS)
	    en[id*MAX_CHIPS*MAX_LINKS+chip] = data;
	  if(newlog==2)
	    nread = fscanf(input,"%s",texta);
	}
      }
      fclose(input);
    }
      */
  }

  ps->Close();
  strun->Close();
  fclose(output);

  // plot noise from fit

  sprintf(line,"%sNOQscan_sum%d_%d.ps",PS_DIRECTORY,run,scan);
  ps = new TPostScript(line,112);
  ps->NewPage();
  c3->cd();
  c3->Clear();
  
  pad_t = new TPad("pad_t","Text",        0.00,0.90,1.00,1.00);
  pad_p = new TPad("pad_p","Projections",   0.00,0.00,1.00,0.90);
  pad_t->Draw();
  pad_p->Draw();
  
  TPaveText *t1 = new TPaveText(0.0,0.0,1.0,1.0);
  t1->SetFillColor(10);
  t1->SetTextAlign(13);
  t1->SetTextSize(0.3);
  t1->SetTextColor(4);
  sprintf(line,"ATLAS SCT - Noise from occupancy");
  if(time)  sprintf(line,"%s  -  %s",line,time->GetName());
  if(place) sprintf(line,"%s  -  %s",line,place->GetName());
  t1->AddText(line);
  
  sprintf(line,"Run %d   Scan %d", run, scan);
  sprintf(line,"%s  -  noise estimated from a linear fit to (log n.o. vs Qthr2)",line);
  t1->AddText(line);
  pad_t->cd();
  t1->Draw();
  
  TGraph* sum = new TGraph(nsum,chipid,qn);
  for(i=0;i<nmod*12;i++)
    chipid[i] = (Float_t) i;
  TGraph* gre = new TGraph(nmod*12,chipid,en);
  leg = new TLegend(.8,.9,1.,1.);
  leg->SetTextSize(0.03);

  pad_p->cd();
  // draw graph
  pad_p->Range(-15,1000,nmod*12+10,2100);
  TGaxis *xax = new TGaxis(0,1100,nmod*12,1100,0,nmod,6*100+nmod,"U");
  xax->SetName("xaxis");
  xax->SetTitle("Module");
  xax->Draw();
  TGaxis *yax = new TGaxis(0,1100,0,2000,1100,2000,808,"");
  yax->SetName("yaxis");
  yax->SetTitle("Noise (ENC)");
  yax->Draw();
  for(i=0;i<=nmod;i++){
    l = new TLine(i*12,1100,i*12,2000);
    l->Draw();
  }
  for(i=0;i<nmod;i++){
    TText t;
    t.SetTextSize(0.04);
    t.DrawText((Double_t)(i*12+1),1060.,mname[i]);
  }
  l = new TLine(0,2000,nmod*12,2000);
  l->Draw();
  sum->SetTitle("Noise from fit");
  sum->SetMarkerStyle(20);
  sum->SetMarkerSize(1);
  sum->SetMarkerColor((Color_t) 1);
  sum->SetMinimum(2000.);
  sum->SetMaximum(1100.);
  gre->SetMarkerStyle(20);
  gre->SetMarkerSize(1);
  gre->SetMarkerColor((Color_t) 2);
  gre->SetLineColor((Color_t) 2);
  sum->Draw("PL");
  gre->Draw("PL");
  leg->AddEntry(sum,"noise occupancy","p");
  leg->AddEntry(gre,"3pt gain, e-stand","p");
  leg->Draw();

  c3->Update();

  ps->Close();

  return;
}
