void NOQscan_strip(Int_t run, Int_t scan){
  #ifdef DATA_DIRECTORY
    // do not reload parameters.h
  #else
    // must load parameters.h
  #include <parameters.h>
  #endif

  Int_t i, nbins, link, chip, strip, ngood, ngood2, nmod, nsum, nread, id,newlog;
  Float_t x[200],y[200], x2[200],y2[200], content, qthr, evcnt, dy[200],dy2[200],dx[200];
  Float_t en[MAX_MODULES*MAX_CHIPS*MAX_LINKS],qn[MAX_MODULES*MAX_CHIPS*MAX_LINKS],chipid[MAX_MODULES*MAX_CHIPS*MAX_LINKS];
  Float_t mvthr,data;
  char h_name[32], line[1024],mname[MAX_MODULES][32];
  Char_t texta[1024],textb[1024],dbasedir[128];
  TH1F *tmp=0, *hevcnt=0, *fit[2][MAX_MODULES];
  TH2F *hscan0=0, *hscan1=0;
  TCanvas* c3 =0;
  TObjString *name. *time, *place;
  TGraphErrors *gr2=0;

  c3= new TCanvas ("c3","NO",1100,750);

  gROOT->LoadMacro("stan_util.cpp");
  gROOT->LoadMacro("ToolBox.cpp");
  gROOT->LoadMacro("mV2fC.cpp");
  gROOT->LoadMacro("fC2mV.cpp");
  //gROOT->LoadMacro("PosProjY.cpp");
  gROOT->LoadMacro("estand_secind_data.cpp");


  TFile* strun;
  sprintf(line,"%sstrun%d_%d.root",DATA_DIRECTORY,run,scan);
  strun = new TFile(line);

  TFile* output;
  sprintf(line,"%sNO%d_%d.root",RESULTS_DIRECTORY,run,scan);
  output = new TFile(line,"RECREATE");

  TF1* f1;
  sprintf(h_name,"f1");
  f1 = new TF1(h_name, "pol1",  0, 3);
  
  nmod = 0;
  nsum = 0;
  for(id=0;id<MAX_MODULES;id++){

    sprintf(h_name,"h_scan0;%d",id+1);
    if(hscan0) hscan0->Delete();
    hscan0 = (TH2F*)strun->Get(h_name);
    sprintf(h_name,"h_scan1;%d",id+1);
    if(hscan1) hscan1->Delete();
    hscan1 = (TH2F*)strun->Get(h_name);
    sprintf(h_name,"h_scan_evcnt;1");
    if(hevcnt) hevcnt->Delete();
    hevcnt = (TH1F*)strun->Get(h_name);
    
    sprintf(h_name,"ModuleName;%d",id+1);
    if(id==0){
      time  = (TObjString*)strun->Get("Time");
      place = (TObjString*)strun->Get("Place");
    }
    name = (TObjString*)strun->Get(h_name);
    if(name)
      sprintf(mname[id],"%s",name->GetName());
    else
      break;
    if(!strcmp(mname[id],"missing")) break;

    nmod++;

    for(link=0;link<2;link++){
      sprintf(h_name,"h_fit%d_%d",link,id+1);
      sprintf(line,"log-fit to occupancy, Module %s Link %d",mname[id],link);
      fit[link][id] = new TH1F(h_name,line,768,0,768);
    }

    c3->cd();
    c3->Clear();
    
    pad_t = new TPad("pad_t","Text",        0.00,0.90,1.00,1.00);
    pad_p = new TPad("pad_p","Projections",   0.00,0.00,1.00,0.90);
    pad_t->Draw();
    pad_p->Draw();
    pad_p->Divide(1,2,0,0);
    
    TPaveText *t1 = new TPaveText(0.0,0.0,1.0,1.0);
    t1->SetFillColor(10);
    t1->SetTextAlign(13);
    t1->SetTextSize(0.3);
    t1->SetTextColor(4);
    sprintf(line,"ATLAS SCT Noise Occupancy");
    sprintf(line,"%s  -  log n.o. vs Qthr2",line);
    if(time)  sprintf(line,"%s  -  %s",line,time->GetName());
    if(place) sprintf(line,"%s  -  %s",line,place->GetName());
    t1->AddText(line);
    
    sprintf(line,"Run %d   Scan %d   Module %d (%s)", run, scan, id, mname[id]);
    t1->AddText(line);
    pad_t->cd();
    t1->Draw();
    
    pad_p->cd();
    for(link=0;link<MAX_LINKS;link++){
      for(strip=0;strip<MAX_CHIPS*128;strip++){
	chip = strip/128;
	if(tmp) tmp->Delete();
	if(link==0)
	  tmp = (TH1F*) hscan0->ProjectionY("tmp",strip,(strip+1));
	else
	  tmp = (TH1F*) hscan1->ProjectionY("tmp",strip,(strip+1));
	nbins = tmp->GetNbinsX();
	ngood=0;
	ngood2=0;
	for(i=0;i<nbins;i++){
	  content = (Float_t) tmp->GetBinContent(i+1);
	  evcnt = (Float_t) hevcnt->GetBinContent(i+1);
	  if(evcnt<1) evcnt=1;
	  qthr = tmp->GetBinCenter(i+1);
	  mvthr = (Float_t) fC2mV(mname[id],chip+6*link,(Float_t) qthr);
	  /* 2.5mV  DAC bit */
	  mvthr = (Float_t) ((int)(((float)mvthr+1.25)/(float)2.5)) * (float)2.5;
	  qthr = (Float_t) mV2fC(mname[id],chip+6*link,(Float_t) mvthr);
	  if(qthr>0.0){ 
	    if(content>5e-9){
	      x[ngood] = qthr*qthr;
	      y[ngood] = TMath::Log(content);
	      dx[ngood] = 0.;
	      //dy[ngood] = (1+(evcnt*content))*(1+(evcnt-(evcnt*content))) / evcnt;
	      dy[ngood] = TMath::Sqrt((1-content)/evcnt/content/128.);
	      //y[ngood] = content;
	      ngood++;
	    }
	    else
	      break;
	    if(qthr>0.5){ 
	      x2[ngood2] =  x[ngood-1];
	      y2[ngood2] =  y[ngood-1];
	      dy2[ngood2] = dy[ngood-1];
	      ngood2++;
	    }
	  }
	}
	
	if(ngood2 >0) {  
	  if(gr2) gr2->Delete();
	  gr2 = new TGraphErrors(ngood2,x2,y2,dx,dy2);
	  gr2->Fit("f1","q");
	  data = (Float_t) 1./TMath::Sqrt(-2.*f1->GetParameter(1))/1.6e-4;
	  fit[link][id]->SetBinContent(strip,data);
	} else{
	  fit[link][id]->SetBinContent(strip,0.);
	}
      }
      pad_p->cd(link+1);
      fit[link][id]->Draw();
      fit[link][id]->Write();
    }
    
    c3->Update();
  }

  strun->Close();
  output->Close();

  return;
}
