void nL1ATest(){
  
#define TRG_BST   25000

  Int_t tottrg=25000;
  Float_t thr_chg=1.,orgocc;
  Int_t del=3;
  Int_t n_bursts = (Int_t) tottrg/TRG_BST;
  Char_t s[512];

  gROOT->ProcessLine(".L AccumBursts.cpp");
  gROOT->ProcessLine(".L sleep.cpp");

  //Store settings before the scan
  e->SaveState();

  // Configure the scan

  e->StOutScanReset();
  e->ascii_nt=0;

  e->do_cal_loop=0;       // cal loop OFF
  e->do_fits=0;           // integrated fitting OFF
  e->do_vary_ntrigs=0;    // don't increase number of triggers
  e->do_autostop=0;        // autostop OFF
  e->do_mask_test=0;       // alternating mask patterns OFF 
  //e->config_frequency = 0; // do NOT send full configuration before each event

  e->burst_ntrigs = TRG_BST;
  e->burst_maxtrigs = 3000000;
  e->ConfigureVariable(11,1);  // X1X compression 
  e->ConfigureVariable(13,0);  // EDGE DETECT OFF
  e->ConfigureVariable(14,0);  // Route Mask OFF
  e->ConfigureVariable(41,thr_chg); // set Qthr

  // normal trigger
  e->burst_type = 1;
  e->burst_trtype = 0;
  e->L1A_per_loop = 1;
  e->ConfigureVariable(45,e->L1A_per_loop);
  e->throw_away = 0;
  e->ExecuteConfigs();
  sleep(1);
  e->ExecuteBurst();
  st_display_burst();
  orgocc = e->m[7]->FractionalOccupancy(0);
  
  // double trigger
  e->burst_type = 100;
  e->burst_trtype = 0;
  e->L1A_per_loop = 1;
  e->ConfigureVariable(45,e->L1A_per_loop);
  e->throw_away = 0;
  /*
  e->burst_trtype = 53;  
  e->L1A_per_loop = 2;
  e->ConfigureVariable(45,e->L1A_per_loop);
  e->throw_away = 1;
  */
  e->ExecuteConfigs();
  sleep(1);
  // reset abort flag
  e->abort = 0;
  st_start_stopper();
  while(!st_do_stop()){
    //e->ConfigureVariable(46,20*del);
    sleep(1);
    if(st_do_stop()) break;
    e->ExecuteBurst();
    st_display_burst();
    printf("\n\nOcc was %.3e, is now %.3e\n\n\n",orgocc,e->m[7]->FractionalOccupancy(0));
  }
  st_stop_stopper();

  e->RestoreState();

}
