void tpg(Int_t do_ana=1){

  // version 0.1 PWP 15.10.00
  // version 0.4 PWP 23.11.00
  // modified for system test analysis

  #ifdef DATA_DIRECTORY
    // do not reload parameters.h
  #else
    // must load parameters.h
  #include <parameters.h>
  #endif

  Int_t n_points = 3;
  Int_t special_point = 1;
  Int_t scans[3], t_HVupdate;
  Float_t charges[3] = {1.50,2.00,2.50};

  Short_t fit_type = 4;   // linear fit

  TDatime* dt = new TDatime();

  // load DCS communication macro
  gROOT->ProcessLine(".L systest/DCSSafety.cpp");

  // Save settings before the scan
  e->SaveState();

  // Configure the scan
  e->StOutScanReset();
  e->ascii_nt=0;
  e->abort=0;

  e->do_cal_loop=1;        // cal loop ON
  e->do_fits=1;            // integrated fitting ON

  e->burst_trtype = 3;     // CAL + L1A
  e->burst_ntrigs = 1000;

  e->ConfigureVariable(11,1);  // X1X compression 
  e->ConfigureVariable(13,0);  // EDGE DETECT OFF
  e->ConfigureVariable(14,0);  // Route Mask OFF

  if(e->abort==0){
    if(DCSSafety(kTRUE)) return;
    e->ConfigureVariable(42,charges[0]);  // 42 - QCAL in fC
    e->ConfigureScan(1,25,250,5);
    st_scan(11,-1);
    //st_scan(20,-1);
    scans[0]=e->scannum;
  }

  if(e->abort==0){
    if(DCSSafety(kTRUE)) return;
    e->ConfigureVariable(42,charges[1]);
    e->ConfigureScan(1,50,300,5);
    st_scan(11,-1);
    //st_scan(20,-1);
    scans[1]=e->scannum;
  }

  if(e->abort==0){
    if(DCSSafety(kTRUE)) return;
    e->ConfigureVariable(42,charges[2]);
    e->ConfigureScan(1,75,350,5);
    st_scan(11,-1);
    //st_scan(30,-1);
    scans[2]=e->scannum;
  }

  // Restore settings
  e->RestoreState();

  if(DCSSafety(kFALSE)) return;

  // run analysis
  gROOT->ProcessLine(".L ENCsum.cpp");
  if(e->abort==0 && do_ana) ENCsum(e->runnum, e->scannum-2);

  return;
}
