# makefile.inc for SCTDAQ
# BJG and PWP 23.05.02
# JCH 25.06.02. All changes for different UNIX implementations are
# in this file. Individual makefiles in the directories should work
# on all UNIX platforms.

SCTPATH = /home/sct/sctdaq
#SCTPATH = /usera/hill/sctdaq
SCTLIBS = $(SCTPATH)/lib
SCTBIN = $(SCTPATH)/bin

# NIVXI LINUX
NIVXIPATH = /usr/local/nivxi
ACC = gcc
CCFLAGS = $(INCLUDES) -I$(NIVXIPATH)/include -O -Wall -DVXILINUX -DNIVXI -D_REENTRANT -D_GNU_SOURCE -fPIC 
CCLIB = -L$(NIVXIPATH)/lib -lnivxi
CXXFLAGS= $(CCFLAGS)
INCDIR = -I$(NIVXIPATH)/include
LD= cc -w -g

# RAID atsct01
# CCFLAGS=  -DSTRINGS_ALIGNED -DNoNeedFunctionPrototypes=0 -D_NO_PROTO\
#	-DSNAPSHOT -w -g -v
# ACC= cc
# CERN_ROOT=/cern/pro
# CCLIB= -L/usr/people/sctdaq/PDAQ/libs/eplx -lRD13
# LD= cc -w -g
#SCTFLAGS= -DRAID

# ATLAS RCC 
#ACC = gcc
#RCCPATH = /scratch/RCC/RCC_Rel_3/build_area
#INCDIR = -I$(RCCPATH)/include
#CCFLAGS = -DRCC $(INCDIR)
#CXXFLAGS= $(INCLUDES) -O -Wall -DRCC -fPIC -D_REENTRANT -D_GNU_SOURCE
#CCLIB = -L$(RCCPATH)/lib -lvme_rcc -lcmem_rcc -lrcc_error
#LD = $(ACC) -w -g

%.d: %.c
	set -e; $(CC) -MM $(CPPFLAGS) $< \
           | sed 's/\($*\)\.o[ :]*/\1.o $@ : /g' > $@; \
           [ -s $@ ] || rm -f $@

%.d: %.cpp
	set -e; $(CC) -MM $(CXXFLAGS) $< \
           | sed 's/\($*\)\.o[ :]*/\1.o $@ : /g' > $@; \
           [ -s $@ ] || rm -f $@
