
/* 
 * hvtest.c :  scthv test program
 * version 0.2 PWP 26.07.00
 * version 0.3 PWP 12.07.01 - support for multiple cards
 * version 0.4 PWP 31.01.02
 * version 0.5 PWP 24.05.02 - remove redundant sleep routine
 */

#include <stdlib.h>
#include <stdio.h>

#ifdef RAID

#include <posix/time.h>
#endif

#include "scthv_lib.h"
#include "../stlib/sct_hardware.h"


void scthv_menu();

main(){
  unsigned long address;
  short code;
  short id=0;

  address = SCTHV_ADDRESS;

  for(id=0;id<SCTHV_NUMBER;id++){
    printf("lvtest: mapping SCTHV card %d at address %8x\n", id, address);

    code = scthv_vmemap(address,&id);
    printf(" ... status %d for address %x\n",code,address);
    if (code != 0) {
      printf("st_vmemap: FAILED with code %d for SCTHV card %d at address %x; proceed ?\n", 
              id, code, address);
    //  return -1;
    }
 
    address+=SCTHV_SPACING;
  }
 
  scthv_menu();
 
  return 0;  
}

void scthv_menu() {
  char cm[128];
  char c;
  int rcode = 0;
  float fv = 0.0;
  float fi = 0.0;
  short r = 0;
  int run = 1;

  short card=0;
  short chan=0;

  printf("\n");

  while(run) {
    printf("\n");
    printf("SCTHV: 1(on) 0 (off) r(request ramp) s(show status)\n");
    printf("       p(rePeat ramp) d(set_carD) i(set_chan_Id) x(exit)\n");
    scanf("%1s", cm);
    c = cm[0];
    if (c == 'x') run = 0;
    /*
     * Do not call scthv_print_status immediately after
     * a different command - the first command is ignored!!
     * PWP 26.07.00
     */ 
    else if (c == '1'){
      rcode=scthv_on(card,chan);
      if(rcode!=0){
        scthv_print_error(rcode,card,chan);
      }
    }
    else if (c == '0'){
      rcode=scthv_off(card,chan); 
      if(rcode!=0){
        scthv_print_error(rcode,card,chan);
      }
    }
    else if (c == 's'){
      rcode=scthv_print_status(card,chan);
      if(rcode!=0){
        scthv_print_error(rcode,card,chan);
      }
    }
    else if (c == 'p'){
      rcode=scthv_repeat_request(card,chan);
      if(rcode!=0){
        scthv_print_error(rcode,card,chan);
      }
    }
    else if (c == 'r'){
 
      printf("SCTHV: enter new Vdet (0-500V): ");
      scanf("%f", &fv);
      printf("SCTHV: enter new Ilim (0-5000 microA): ");
      scanf("%f", &fi);
      printf("SCTHV: enter new ramp rate (1(fast)-4(slow)): ");
      scanf("%hd", &r);

      printf("       You have selected Vdet %3.2f, Ilim %4.2f, ramp %hd for card %d chan %d\n",
             fv, fi, r, card, chan);
      printf("       Do you wish to proceed (0/1)? ");
      scanf("%d", &rcode);

      if(rcode==1){
        rcode=scthv_request(card,chan,fv,fi,r);
        if(rcode!=0){
          scthv_print_error(rcode,card,chan);
        }
      }
    }
    else if (c == 'd') { 
      printf("SCTHV: enter new card id (0-%d): ",SCTHV_NUMBER-1); 
      scanf("%d", &r); 
      card = r; 
      printf(" ... card id set to %d\n", card);
      rcode=scthv_print_status(card,chan);
      if(rcode!=0){
        scthv_print_error(rcode,card,chan);
      }
    }
    else if (c == 'i') { 
      printf("SCTHV: enter new channel id (0-3): "); 
      scanf("%d", &r); 
      chan = r; 
      printf(" ... channel id set to %d\n", chan);
      rcode=scthv_print_status(card,chan);
      if(rcode!=0){
        scthv_print_error(rcode,card,chan);
      }
    }
    else printf("SCTHV: ERROR: unknown command %c\n", c);
  }
  printf("\n");
  // scthv_off(card,chan);
}

