
/* abc_config.h  Function prototypes for ABC/D control block generation */

/* GFM Nov98
 * GFM 990525 Split from abc.h
 * PWP 10.01.00 make all cb size parameters type unsigned int
 *              (same type as used by slog library)
 * PWP 29.11.00 addition of forward_sc_command
 */


static unsigned short chipid[CHIPS_IN_MODULE]={0x0000,0x0040,0x0080,0x00c0,0x0100,0x0140,
                                               0x0200,0x0240,0x0280,0x02c0,0x0300,0x0340};


/* Function prototypes */

#if defined(__STDC__)

int abc_allchips(module_cfg *mcfg, unsigned short *cb, unsigned int *cb_size);
int abc_configure(module_cfg *mcfg, unsigned short *cb, unsigned int *cb_size, short full_config);
int abc_trims(module_cfg *mcfg, int chip, unsigned short *cb, unsigned int *cb_size);
int cb_clear(unsigned short *cb, unsigned int size);
int cb_merge(unsigned short *cb0, unsigned short *cb1, unsigned short *out, unsigned int size);
int cb_rotate(   
  unsigned short *in, unsigned int inl, 
  unsigned short *out, unsigned int *outl, unsigned short mask);
int cb_cat(
  unsigned short *a, unsigned int *al, unsigned short *b, unsigned int bl);
int abc_default(short chipset, short evenodd, short ntop, short nbot, module_cfg *md);
int abc_show_config( module_cfg *md);
int abc_global_dacs(float vcal, float vthr, unsigned short *cbword);
int abc_global_delay(float delay, unsigned short *cbword);
int abc_global_bias( float febias, float feshaper, unsigned short *cbword);
int abc_global_enabledata( unsigned short *cbword);
int abc_pulse_input(unsigned short *cbword, unsigned int *cb_size);
int abc_command(unsigned short *cbword, unsigned int *cb_size, int com1, int com2, int ntrigs, unsigned short delay1, unsigned short delay2, unsigned short delay3);
int abc_echo_event(short l1, short bc, short chip, short strip, short bins, unsigned short *cb);
int abc_sendid(module_cfg *mcfg, short link, unsigned short *db, int *db_size);
void db_fill(unsigned short *db, int *db_size, unsigned int dword, short nbits);
int abc_seu_setup(unsigned short *cb, unsigned int *cb_size, short seu_invert);
int sc_configure(module_cfg *mcfg, unsigned short *cb, unsigned int *cb_size);

#else

int abc_allchips();
int abc_configure();
int abc_trims();
int cb_clear();
int cb_merge();
int cb_rotate();
int cb_cat();
int abc_default();
int abc_show_config();
int abc_global_dacs();
int abc_global_delay();
int abc_global_bias();
int abc_global_enabledata();
int abc_pulse_input();
int abc_command();
int abc_echo_event();
int abc_sendid();;
void db_fill();
int abc_seu_setup();
int sc_configure();

#endif




