/*
 * st_config.h:   SCT Test system configuration function prototypes.
 *                Note, these functions manipulate the system configuration,
 *                that is, association and state of readout channels, not
 *                module-specific attributes.
 *
 * (formerly sct_config.h, renamed for purely cosmetic reasons)
 *
 * GFM 1998
 * last revised PWP 19.03.99 - add prototypes for JLB's routines
 * sct_read_sysconf() and sct_read_moduleconf()
 * GFM May99 Split from sct.h
 * GFM Jul99 Add st_scanpoint_file(), RAID compatibility
 * PWP 04.08.99 replace "sct*" by "st*", add read/show trimdacs
 * PWP 12.11.99 add st_read_rc and st_show_rc
 * PWP 23.11.00 add st_set_rc
 * PWP 29.08.01 add st_write_module
 * PWP 14.11.02 add st_write_module_xml
 */


static char roles[6][8]= {"missing", "   dead", "    end", " master", "  slave", " lonely"};    


#if defined(__STDC__)

int  st_default_sysmap();
int  st_electro_sysmap();

int  st_read_sysmap();
int  st_show_sysmap();
void st_menu_sysmap();

int  st_read_module(int mid);
void st_show_module(int mid);
int st_write_module(int mid, int run, int scan);
int st_write_module2(int mid, int run, int scan);
int st_write_module_xml(int mid, int run, int scan, float version, char* location);

int  st_read_trims(int mid);
int  st_show_trims(int mid);

int  st_read_rc(int mid);
int  st_show_rc(int mid);
int  st_get_rc(int mid, int cid, short* method, short* function, 
               float* p0, float* p1, float* p2);
int  st_set_rc(int mid, int cid, short method, short function, 
               float p0, float p1, float p2);


int  st_read_mask(int mid);
int  st_mask_chan(int mid, short chan);

int  st_scanpoint_file(int index);

void st_reverse_sysmap();
short st_find_link(short mid, short sid);
short st_find_module(short mid, short sid);
short st_find_mustard(short m);
short st_find_stream(short m, short soft_link);
short st_find_maxchips(short mid);

short st_find_optif_id(short m);
short st_find_optif_tx_ch(short m);
short st_find_optif_rx_ch0(short m);
short st_find_optif_rx_ch1(short m);

short st_n_active_channels(short mid);

#else

int  st_default_sysmap();
int  st_electro_sysmap();

int  st_read_sysmap();
int  st_show_sysmap();
void st_menu_sysmap();

int  st_read_module();
void st_show_module();
int st_write_module();
int st_write_module2();
int st_write_module_xml();

int  st_read_trims();
int  st_show_trims();

int  st_read_rc();
int  st_show_rc();
int  st_get_rc();
int  st_set_rc();

int  st_read_mask();
int  st_mask_chan();

int  st_scanpoint_file();

void st_reverse_sysmap();
short st_find_link();
short st_find_module();
short st_find_mustard();
short st_find_stream();
short st_find_maxchips();

short st_find_optif_id();
short st_find_optif_tx_ch();
short st_find_optif_rx_ch0();
short st_find_optif_rx_ch1();

short st_n_active_channels();

#endif
