abcd2t_calib(short nmods){

  //  Performs a set of Threshold scans to determine the response curve 
  //  Scans are to be fitted with stan_fitscan.cpp, this is presently
  //  done last just in case ROOT should crash!!
  //  Updated for multiple modules, PWP 04.08.00

  e->StOutScanReset();
  e->ascii_nt=0;

  e->ConfigureVariable( 2,10.0);
  e->ConfigureScan(1, 0,200,2.5);
  st_scan(1,-1);

  Int_t start_scan = e->scannum;

  e->ConfigureVariable( 2,15.0); 
  e->ConfigureScan(1, 0,250,2.5);
  st_scan(1,-1);

  e->ConfigureVariable( 2,20.0); 
  e->ConfigureScan(1,100,300,2.5);
  st_scan(1,-1);

  e->ConfigureVariable( 2,25.0); 
  e->ConfigureScan(1,130,330,2.5);
  st_scan(1,-1);

  e->ConfigureVariable( 2,30.0); 
  e->ConfigureScan(1,160,360,2.5);
  st_scan(1,-1);

  e->ConfigureVariable( 2,35.0); 
  e->ConfigureScan(1,190,390,2.5);
  st_scan(1,-1);

  e->ConfigureVariable( 2,40.0); 
  e->ConfigureScan(1,220,420,2.5);
  st_scan(1,-1);

  e->ConfigureVariable( 2,45.0); 
  e->ConfigureScan(1,250,450,2.5);
  st_scan(1,-1);

  e->ConfigureVariable( 2,50.0); 
  e->ConfigureScan(1,280,480,2.5);
  st_scan(1,-1);

  e->ConfigureVariable( 2,55.0); 
  e->ConfigureScan(1,320,530,2.5);
  st_scan(1,-1);

  e->ConfigureVariable( 2,60.0); 
  e->ConfigureScan(1,350,580,2.5);
  st_scan(1,-1);

  // Load fit macros

  gROOT->ProcessLine(".L stan_fitscan.cpp");
  gROOT->ProcessLine(".L stan_fitrc.cpp");

  // fit scan data

  Int_t i,j;
  for(j=0;j<nmods;j++){
    for(i=start_scan;i<start_scan+11;i++){ 
      stan_fitscan(e->runnum,i,j,0,1,0);
      stan_fitscan(e->runnum,i,j,1,1,0);
    }
    stan_fitrc(e->runnum,start_scan,j,0,0,1,1,1);
    stan_fitrc(e->runnum,start_scan,j,1,0,1,1,1);
  }
}

abcd2t_calib(){
  abcd2t_calib(1);
}

